if (this.JSON && this.JSON.stringify.toString().indexOf('[native code]') !== -1) {
  this.JSONDAO = this.JSON;
} else {
  this.JSONDAO = {};
}

(function() {
  function f(n) {
    return n < 10 ? '0' + n : n;
  }

  if (typeof Date.prototype.toJSON !== 'function') {
    Date.prototype.toJSON = function(key) {
      return isFinite(this.valueOf()) ? this.getUTCFullYear() + '-' +
      f(this.getUTCMonth() + 1) + '-' +
      f(this.getUTCDate()) + 'T' +
      f(this.getUTCHours()) + ':' +
      f(this.getUTCMinutes()) + ':' +
      f(this.getUTCSeconds()) + 'Z' : null;
    };
    String.prototype.toJSON = Number.prototype.toJSON = Boolean.prototype.toJSON = function(key) {
      return this.valueOf();
    };
  }
  var cx = /[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,escapable = /[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,gap,indent,meta = {'\b':'\\b','\t':'\\t','\n':'\\n','\f':'\\f','\r':'\\r','"':'\\"','\\':'\\\\'},rep;

  function quote(string) {
    escapable.lastIndex = 0;
    return escapable.test(string) ? '"' + string.replace(escapable, function(a) {
      var c = meta[a];
      return typeof c === 'string' ? c : '\\u' + ('0000' + a.charCodeAt(0).toString(16)).slice(-4);
    }) + '"' : '"' + string + '"';
  }

  function str(key, holder) {
    var i,k,v,length,mind = gap,partial,value = holder[key];
    if (value && typeof value === 'object' && typeof value.toJSON === 'function') {
      value = value.toJSON(key);
    }
    if (typeof rep === 'function') {
      value = rep.call(holder, key, value);
    }
    switch (typeof value) {case'string':return quote(value);case'number':return isFinite(value) ? String(value) : 'null';case'boolean':case'null':return String(value);case'object':if (!value) {
      return'null';
    }
      gap += indent;partial = [];if (Object.prototype.toString.apply(value) === '[object Array]') {
        length = value.length;
        for (i = 0; i < length; i += 1) {
          partial[i] = str(i, value) || 'null';
        }
        v = partial.length === 0 ? '[]' : gap ? '[\n' + gap +
        partial.join(',\n' + gap) + '\n' +
        mind + ']' : '[' + partial.join(',') + ']';
        gap = mind;
        return v;
      }
      if (rep && typeof rep === 'object') {
        length = rep.length;
        for (i = 0; i < length; i += 1) {
          k = rep[i];
          if (typeof k === 'string') {
            v = str(k, value);
            if (v) {
              partial.push(quote(k) + (gap ? ': ' : ':') + v);
            }
          }
        }
      } else {
        for (k in value) {
          if (Object.hasOwnProperty.call(value, k)) {
            v = str(k, value);
            if (v) {
              partial.push(quote(k) + (gap ? ': ' : ':') + v);
            }
          }
        }
      }
      v = partial.length === 0 ? '{}' : gap ? '{\n' + gap + partial.join(',\n' + gap) + '\n' +
      mind + '}' : '{' + partial.join(',') + '}';gap = mind;return v;
    }
  }

  if (typeof JSONDAO.stringify !== 'function') {
    JSONDAO.stringify = function(value, replacer, space) {
      var i;
      gap = '';
      indent = '';
      if (typeof space === 'number') {
        for (i = 0; i < space; i += 1) {
          indent += ' ';
        }
      } else if (typeof space === 'string') {
        indent = space;
      }
      rep = replacer;
      if (replacer && typeof replacer !== 'function' && (typeof replacer !== 'object' || typeof replacer.length !== 'number')) {
        throw new Error('JSONDAO.stringify');
      }
      return str('', {'':value});
    };
  }

  if (typeof JSONDAO.parse !== 'function') {
    JSONDAO.parse = function(text, reviver) {
      var j;

      function walk(holder, key) {
        var k,v,value = holder[key];
        if (value && typeof value === 'object') {
          for (k in value) {
            if (Object.hasOwnProperty.call(value, k)) {
              v = walk(value, k);
              if (v !== undefined) {
                value[k] = v;
              } else {
                delete value[k];
              }
            }
          }
        }
        return reviver.call(holder, key, value);
      }

      text = String(text);
      cx.lastIndex = 0;
      if (cx.test(text)) {
        text = text.replace(cx, function(a) {
          return'\\u' +
            ('0000' + a.charCodeAt(0).toString(16)).slice(-4);
        });
      }
      if (/^[\],:{}\s]*$/.test(text.replace(/\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g, '@').replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g, ']').replace(/(?:^|:|,)(?:\s*\[)+/g, ''))) {
        j = eval('(' + text + ')');
        return typeof reviver === 'function' ? walk({'':j}, '') : j;
      }
      throw new SyntaxError('JSONDAO.parse');
    };
  }
}());
/**
 * Javascript TranslatoR 组件 JTR 的基础库.
 *
 * @module J
 * @author zhangyc
 * @author wulj
 */

/**
 * 实现一个轻量级的 JavaScript 库
 * TODO：对象重命名
 * @class J
 * @namespace outfox.translate.JTR
 */
(function() {

  var J = {

    /**
     * 浏览器类型及版本号判断
     */
    browser: function() {
      var bro = {};
      var ua = navigator.userAgent.toLowerCase();
      var s;
      (s = ua.match(/msie ([\d.]+)/)) ? bro.msie = s[1] :
        (s = ua.match(/firefox\/([\d.]+)/)) ? bro.firefox = s[1] :
          (s = ua.match(/chrome\/([\d.]+)/)) ? bro.chrome = s[1] :
            (s = ua.match(/opera.([\d.]+)/)) ? bro.opera = s[1] :
              (s = ua.match(/version\/([\d.]+).*safari/)) ? bro.safari = s[1] : 0;
      return bro;
    }(),

    /**
     * 判断元素是否是 DOM 结点
     *
     * @method isDOM
     * @static
     * @param {Object}elem
     * @return {Boolean}
     */
    isDOM : function(elem) {
      return Boolean(elem && elem.nodeType === 1);
    },
    /**
     * 判断元素是否是 数组
     *
     * @method isArray
     * @static
     * @param {Object}obj 待判断元素
     * @return {Boolean} 是否数组 true 为数组
     */
    isArray: function(obj) {
      return Object.prototype.toString.call(obj) === '[object Array]';
    },
    /**
     * 判断一个 object 是否是一个 Function
     *
     * @method isFunction
     * @static
     * @param {Object}obj
     * @return {Boolean}
     */
    isFunction :function(obj) {
      return Object.prototype.toString.call(obj) === "[object Function]";
    },

    /**
     * 迭代器
     *
     * @method each
     * @static
     * @param {Object}object
     * @param {Function}callback 回调函数
     * 回调格式：当object为对象时，callback(key,value) 上下文为 context, 若 context 未定义，那么上下文为 value。
     * 当object为数组或含length属性的htmlcollection时，callback(idx,object[idx])，上下文同上。
     * 回调中断：当某个回调返回值是false时，中断each
     */
    each: function(object, callback, context) {
      if (object === undefined || object === null) {
        return;
      }
      if (object.length === undefined || J.isFunction(object)) {
        for (var name in object) {
          if (object.hasOwnProperty(name)) {  //只有此元素本身属性调用回调
            if (callback.call(context || object[name], name, object[name]) === false) {
              break;
            }
          }
        }
      } else {
        for (var i = 0; i < object.length; i++) {
          if (callback.call(context || object[i], i, object[i]) === false) {
            break;
          }
        }
      }
      return object;
    },

    /**
     * 返回数组或对象中第一个值为 val 对象的 index 或 key
     * @param obj 对象或数组
     * @param val 待检测值
     */
    indexOf:function indexOf(obj, val) {
      if (obj.indexOf) {
        return obj.indexOf(val);
      } else {
        var result = -1;
        J.each(obj, function(idx) {
          if (this === val) {
            result = idx;
            return false;
          }
        });
        return result;
      }
    },

    /**
     * 事件绑定
     *
     * @method bind
     * @param {Object}object
     * @param {String}eventName
     * @param {Function}callback
     */
    bind : function(object, eventName, callback) {
      if (!callback) {
        return;
      }
      if (object.addEventListener) {
        object.addEventListener(eventName, callback, false);
      } else if (object.attachEvent) {
        object.attachEvent('on' + eventName, callback);
      } else {
        object['on' + eventName] = callback;
      }
      return this;
    },

    /**
     * 解除事件绑定函数
     *
     * @method unbind
     * @static
     * @param {Object}object
     * @param {String}eventName
     * @param {Function}callback
     */
    unbind : function(object, eventName, callback) {
      if (!callback) {
        return;
      }
      if (object.removeEventListener) {
        object.removeEventListener(eventName, callback, false);
      } else if (object.detachEvent) {
        object.detachEvent('on' + eventName, callback);
      } else {
        object['on' + eventName] = function() {
        };
      }
      return this;
    },

    /**
     * 为数据做 Percentage Encoding
     * 将参数对象序列化成字符串
     * @method param
     * @static
     * @param {Object}data
     * @return {String}
     */
    param : function(data) {
      if (typeof data === 'string') {
        return data;
      }
      var param = [];
      J.each(data, function(index, value) {
        if (value) {
          // 翻译服务器会对传入的数据先做一次 ISO-8859-1 解码
          // 然后再对数据按照 ue 做一次解码
          // Firefox 3 会在 content-type 后面强制加入 charset=UTF-8
          // 导致服务器在做 ISO-8859-1 解码前先做 UTF-8 解码
          // 会导致中文乱码
          // 所以对于 Firefox 3，需要将数据强制转换成 ISO-8859-1 格式
          value = encodeURIComponent(value);
          if (J.browser.firefox) {
            value = encodeURIComponent(unescape(value)); // 将数据转换成 ISO-8859-1 格式
          }
          param.push(encodeURIComponent(index) + '=' + value);
        }
      });
      return param.join('&');
    },

    /**
     * 将任意对象转化为数组
     *
     * @method makeArray
     * @static
     * @param {Object}obj
     * @return {Array}
     */
    makeArray : function(obj) {
      return Array.prototype.slice.call(obj, 0);
    },

    /**
     * 获取页面编码
     *
     * @method getDocumentCharset
     * @static
     * @return {String}
     */
    getDocumentCharset : function() {
      J.log("document.characterSet || document.charset:::" + document.characterSet || document.charset);
      return document.characterSet || document.charset;
    },

    /**
     * 控制台 Log
     *
     * @method log
     * @static
     */
    log : function() {
      if (!!window.console && !!window.console.log) {
        var args = J.makeArray(arguments);
        args.unshift('[J]');
        try {
          window.console.log.apply(window.console, args);
        } catch(e) {
          if (arguments.length === 3) {
            window.console.log(arguments[0], arguments[1], arguments[2]);
          } else if (arguments.length === 2) {
            window.console.log(arguments[0], arguments[1]);
          } else {
            window.console.log(arguments[0]);
          }
        }
      }
    },

    /**
     * 设置或获取元素样式
     *
     * @method css
     * @static
     * @param {Object}elem
     * @param {Object}styles
     * @return {Object}
     */
    css : function() {
      /**
       * 获取一个元素的样式
       * @param elem
       * @param styleName
       */
      var getStyle = function(elem, styleName) {
        var value = '';
        if (styleName == 'float') {
          document.defaultView ? styleName = 'float'/*cssFloat*/ : styleName = 'styleFloat';
        }
        if (elem.style[styleName]) {//内联样式
          value = elem.style[styleName];
        } else if (elem.currentStyle) {//IE
          value = elem.currentStyle[styleName];
        } else if (document.defaultView && document.defaultView.getComputedStyle) {//W3 DOM
          styleName = styleName.replace(/([A-Z])/g, '-$1').toLowerCase();
          var s = document.defaultView.getComputedStyle(elem, '');
          value = s && s.getPropertyValue(styleName);
        } else { //other,for example, Safari
          value = null;
        }
        //处理width 和 height 出现 auto 或是百分比宽度 的情况
        if ((value == "auto" || value.indexOf('%') !== -1) && ('width' === styleName.toLowerCase() || 'height' === styleName.toLowerCase()) && elem.style.display != "none" && value.indexOf('%') !== -1) {
          value = elem["offset" + styleName.charAt(0).toUpperCase() + styleName.substring(1).toLowerCase()] + "px";
        }
        if (styleName == "opacity") {
          try {
            value = elem.filters['DXImageTransform.Microsoft.Alpha'].opacity;
            value = value / 100;
          } catch(e) {
            try {
              value = elem.filters('alpha').opacity;
            } catch(err) {
            }
          }
        }
        return value;
      };
      return function(elem, styles) {
        if (typeof styles === 'string') {
          return getStyle(elem, styles);
        } else {
          J.each(styles, function(key, value) {
            elem.style[key] = value;
          });
        }
      };
    }(),

    /**
     * 获取窗口的尺寸
     */
    getPageSize:function() {
      var xScroll, yScroll;
      if (window.innerHeight && window.scrollMaxY) {
        xScroll = document.body.scrollWidth;
        yScroll = window.innerHeight + window.scrollMaxY;
      } else { // all but Explorer Mac
        xScroll = Math.max(document.body.scrollWidth, document.body.offsetWidth);
        yScroll = Math.max(document.body.scrollHeight, document.body.offsetHeight);
      }
      var windowWidth, windowHeight;
      windowWidth = document.documentElement.clientWidth || document.body.clientWidth;
      windowHeight = document.documentElement.clientHeight || document.body.clientHeight;

      var pageHeight = Math.max(yScroll, windowHeight);
      var pageWidth = Math.max(xScroll, windowWidth);
      return {
        page:{
          width: pageWidth,
          height: pageHeight
        },
        window:{
          width:windowWidth,
          height:windowHeight
        }
      };
    },

    /**
     * 获取一个元素相对于页面左上角的位置
     * @param elem
     * @return object {x:, y: }
     */
    findPos : function(elem) {
      var offset = {
        x:0,
        y:0
      };
      if (!!document.documentElement.getBoundingClientRect()) {//支持此方法的浏览器可以直接获取位置
        offset.x = elem.getBoundingClientRect().left + J.scroll().left;
        offset.y = elem.getBoundingClientRect().top + J.scroll().top;
      } else {
        while (elem) {
          offset.x += elem.offsetLeft;
          offset.y += elem.offsetTop;
          elem = elem.offsetParent;
        }
      }
      return offset;
    },
    /**
     * 获取选中文本的最高位置，若不支持 getBoundingClientRect ，则取鼠标当前位置。
     * @param evt 事件对象
     * @param resultPos 结果框的显示位置
     */
    textPos:function(evt,resultPos) {
      var event = evt || window.event;
      var range = {};
      var pos = {};
      var horizontal=resultPos.h;
      var vertical=resultPos.v||'bottom';
      if (window.getSelection) {
        range = window.getSelection().getRangeAt(0);
      } else if (document.selection) {
        range = document.selection.createRange();
      }

      if(!!horizontal){
        pos.x = position[horizontal] + J.scroll().left;
      }else{
        if (event.pageX || event.pageY) {
          pos.x = event.pageX;
        } else if (event.clientX || event.clientY) {
          pos.x = event.clientX + J.scroll().left;
        }
      }

      if (!!range.getBoundingClientRect) {
        var position = range.getBoundingClientRect();
        pos.y = position[vertical] + J.scroll().top;
      } else {
        if (event.pageX || event.pageY) {
          pos.y = event.pageY;
        } else if (event.clientX || event.clientY) {
          pos.y = event.clientY + J.scroll().top;
        }
      }
      return pos;
    },
    scroll:function() {
      return {
        left : document.documentElement.scrollLeft + document.body.scrollLeft,
        top : document.documentElement.scrollTop + document.body.scrollTop
      }
    },
    /**
     * 遍历 DOM 结点
     *
     * @method walkTheDOM
     * @static
     * @param {DOMNode}node
     * @param {Function}func  对遍历出的节点所做的操作，上下文为当前 node
     * @param {Function}filter  遍历节点时，忽略不符合过滤条件的元素
     */
    walkTheDOM : function(node, func, filter) {
      if (filter && !filter(node)) {
        return;
      }
      func(node);
      if (node.tagName === 'NOSCRIPT') {
        return;
      } else if (node.tagName === 'IFRAME' || node.tagName === 'FRAME') { //对于frame 和iframe，遍历其中节点
        /*
         try {
         var document = node.contentDocument || node.contentWindow.document;
         node = document.body;
         } catch(e) {
         node = node.firstChild;
         }
         */
        return;
      } else {
        node = node.firstChild;
      }
      while (node) {
        arguments.callee(node, func, filter); //函数对象本身迭代调用
        node = node.nextSibling;
      }
    },

    /**
     * 获取所有文本节点
     * @param node   遍历DOM树时的起始节点
     * @param filter 遍历DOM树时的过滤器
     * @return textNodes 所有文本节点组成的数组
     */
    getTextNodes : function(node, filter) {
      var textNodes = [];

      J.walkTheDOM(node, function(child) {
        if (child.nodeType === 3 && J.trim(child.nodeValue)) {
          textNodes.push(child);
        }
      }, filter);

      return textNodes;
    },

    /**
     * Get elements by class name
     *
     * @method getElementsByClassName
     * @static
     * @param {DOMNode}node
     * @param {String}className
     * @return {Array}
     * todo:两种返回结果类型不一致，node.getElementsByClassName(className)返回的是nodelist，后者是数组
     */
    getElementsByClassName : function(node, className) {
      if (node.getElementsByClassName) {
        return node.getElementsByClassName(className);
      } else {
        var results = [];
        J.walkTheDOM(node, function (node) {
          if (J.hasClass(node, className)) {
            results.push(node);
          }
        });
        return results;
      }
    },

    /**
     * 根据选择器查找出元素
     */
    query:function(selector, root) {
      var chunker = new RegExp('(?:(?:\\.([^()]+))?)(?:(?:#([^()]+))?)');
      var result = chunker.exec(selector);
      var sRoot = root || document;
      if (!result) {
        return null;
      } else {
        if (!!result[1]) {
          var className = result[1];
          if (sRoot.getElementsByClassName) {
            return sRoot.getElementsByClassName(className);
          } else {
            var results = [];
            J.walkTheDOM(sRoot, function (node) {
              if (J.hasClass(node, className)) {
                results.push(node);
              }
            });
            return results;
          }
        }
        if (!!result[2]) {
          return sRoot.getElementById(result[2]);
        }
      }
    },

    /**
     * 去除字符串头尾空白字符
     *
     * @method trim
     * @static
     * @param {String}str
     * @return {String}
     */
    trim : function(str) {
      return str.replace(/^\s*/, "").replace(/\s*$/, "");
    },

    /**
     * Format template string to HTML element
     *
     * @method formatTemplate
     * @static
     * @param {String}template well-formed html string
     * @param {Object}data
     * @return {DOMNode}
     */
    formatTemplate : function(template, data) {
      var tempContainer = document.createElement('div');
      for (var key in data) {
        if (data.hasOwnProperty(key)) {
          template = template.replace(new RegExp('{' + key + '}', 'g'), data[key]);
        }
      }
      tempContainer.innerHTML = template;
      var result = tempContainer.firstChild;
      tempContainer.removeChild(result);
      return result;
    },

    /**
     * 判断元素是否含某个 className
     *
     * @method hasClass
     * @static
     * @param {Object}elem
     * @param {String}className
     * @return {Boolean}
     */
    hasClass : function(elem, className) {
      if (J.isDOM(elem)) {
        if (elem.className === className) {
          return true;
        }

        var classes = elem.className.split(' '), i = 0, len = classes.length;
        for (; i < len; i++) {
          if (className === classes[i]) {
            return true;
          }
        }
      }
      return false;
    },

    /**
     * 动态载入 CSS
     *
     * @method loadCSS
     * @static
     * @param {Object}doc Document object
     * @param {String}url CSS URL
     */
    loadCSS : function(doc, csses) {
      var load = function(single) {
        if (doc && doc.createElement) {
          var timestamp = Date.parse(new Date()),
            css = doc.createElement('link');
          var url = single.indexOf('?') === -1 ? single + '?@REV@' : single + '&@REV@';
          css.setAttribute('rel', 'stylesheet');
          css.setAttribute('href', url);
          css.setAttribute('type', 'text/css');

          var parent = doc.getElementsByTagName('head')[0] || doc.body;
          parent.appendChild(css); // ie下会导致请求/styles/null
        }
      };
      if (J.isArray(csses)) {
        J.each(csses, function(idx, css) {
          load(css);
        });
      } else if (typeof csses === 'string') {
        load(csses);
      }
    },

    /**
     * 为一个 DOM 元素添加 Class
     *
     * @method addClass
     * @static
     * @param {DOMNode}elem
     * @param {String}className
     */
    addClass : function(elem, className) {
      if (J.isDOM(elem)) {
        var classes = elem.className.split(' '), i = 0, len = classes.length;
        for (; i < len; i++) {
          if (className === classes[i]) {
            return;
          }
        }
        classes[i] = className;
        elem.className = classes.join(' ');
      }
    },

    /**
     * 为一个 DOM 元素删除一个 Class
     *
     * @method removeClass
     * @static
     * @param {DOMNode}elem
     * @param {String}className
     */
    removeClass : function(elem, className) {
      if (J.isDOM(elem)) {
        var classes = elem.className.split(' '), i = 0, len = classes.length, newClasses = [];
        for (; i < len; i++) {
          if (className !== classes[i]) {
            newClasses.push(classes[i]);
          }
        }
        elem.className = newClasses.join(' ');
      }
    },

    /**
     * 当一个 DOM 元素包含指定的 class 时，删除该 class；若不含，则增加该 class
     *
     * @method toggleClass
     * @static
     * @param {DOMNode}elem
     * @param {String}className
     */
    toggleClass : function(elem, className) {
      if (J.isDOM(elem)) {
        var classes = elem.className.split(' '), i = 0, len = classes.length, newClasses = [], action = 'add';
        for (; i < len; i++) {
          if (className === classes[i]) {
            action = 'remove';
          } else {
            newClasses.push(classes[i]);
          }
        }

        if (action === 'add') {
          classes[i] = className;
        } else {
          classes = newClasses;
        }
        elem.className = classes.join(' ');
      }
    },

    /**
     * 生成 GUID
     *
     * @method guid
     * @static
     * @return {String}GUID
     */
    guid : function() {
      // 生成 GUID 的辅助函数
      var _S4 = function() {
        return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
      };
      return function() {
        return (_S4() + _S4() + "-" + _S4() + "-" + _S4() + "-" + _S4() + "-" + _S4() + _S4() + _S4());
      };
    }(),

    /**
     * 原型继承
     *
     * @method protoExtend
     * @static
     * @param {Object}obj
     * @return {Object}
     */
    protoExtend : function(obj, constructor) {
      var F = J.isFunction(constructor) ? constructor : function() {
      };
      F.prototype = obj;
      return new F();
    },

    /**
     * 取消事件冒泡
     * @param e 事件对象
     */
    stopPropagation : function(e) {
      var evt = e || window.event;
      if (evt.stopPropagation) {
        evt.stopPropagation();
      }
      evt.cancelBubble = true;
      return evt;
    },
    /**
     * data 本地存储操作，当值参数为空时，是取值功能；都不为空时，为存值功能
     * @param key  键
     * @param value  值
     */
    storage : function(key, value) {
      /**
       * html5 中的本地存储方式
       * @param key
       * @param value
       */
      var html5LocalStorage = function(key, value) {
        var store = window.localStorage;
        if (value === undefined) {
          return store.getItem(key);
        }
        if (key !== undefined && value !== undefined) {
          store.setItem(key, value);
          return value;
        }
      };
      /**
       * IE 特有的存储方式 userData
       * @param key
       * @param value
       */
      var userdata = function(key, value) {
        var store = document.documentElement;
        store.addBehavior("#default#userData");
        if (value === undefined) {
          store.load("fanyiweb2");
          return store.getAttribute(key);
        }
        if (key !== undefined && value !== undefined) {
          store.setAttribute(key, value);
          store.save("fanyiweb2");
          return value;
        }
      };
      if (!!window.localStorage) {
        return html5LocalStorage(key, value);
      }
      if (!!document.documentElement.addBehavior) {
        return userdata(key, value);
      }
    },
    /**
     * cookie 操作
     * @param name cookie 名称
     * @param value cookie 值
     */
    cookie:function(name, value) {
      function setCookies(name, value) {
        var Days = 30; //此 cookie 将被保存 30 天
        var exp = new Date(); //new Date("December 31, 9998");
        exp.setTime(exp.getTime() + Days * 24 * 60 * 60 * 1000);
        document.cookie = name + "=" + value + ";expire*=" + exp.toGMTString();
      }

      function getCookies(name) {
        var arr = document.cookie.match(new RegExp("(^| )" + name + "=([^;]*)(;|$)"));
        if (arr != null) return decodeURIComponent(arr[2]);
        return null;
      }

      if (!!value) {
        setCookies(name, value);
      } else {
        return getCookies(name);
      }
    },
    /**
     * 解析数据方法，将指定类型的数据解析成 JS 的对象类型数据
     * @param type
     * @param data
     */
    parseData:function() {
      var parsers = {
        json:function(data) {
          try {
            return data = JSONDAO.parse(data);
          } catch(e) {
            J.log('[Error]', 'Invalid JSON data:', data);
          }
        },
        xml:function(data) {
          if (window.DOMParser) {
            return (new DOMParser()).parseFromString(data, "text/xml");
          } else {
            var xmlDoc = new ActiveXObject('Microsoft.XMLDOM');
            xmlDoc.async = 'false';
            xmlDoc.loadXML(data);
            return xmlDoc;
          }
        }
      };
      return function(type, data) {
        if (type === undefined) {
          return data;
        }
        /**
         * 优先使用自带解析器
         */
        if (J.isFunction(type)) {
          return type(data);
        }
        if (!!type && !parsers[type]) {
          //本解析器不支持的类型，则记 log，返回原数据
          J.log('[Error]', 'Function parseData() dosen\'t support this type:', type);
          return data;
        }
        return parsers[type](data);
      };
    }(),
    /**
     * 让 js 函数只执行一次
     * @param fn
     */
    once:function(fn) {
      return function() {
        if (J.isFunction(fn)) {
          fn.apply(this, arguments);
        }
        fn = function() {
        };
      }
    }
  };

  window.J = J;
})();
/**
 * 跨域通讯模块
 * 支持3种模式的通信：client -> server->client server->client client->server
 * @module J
 * @submodule CDA
 * @author wulijian
 */

(function(J) {
  var CrossDomainAjax = function(id, domain, url) {
    return new CrossDomainAjax.prototype.init(id, domain, url);
  };

  CrossDomainAjax.prototype = {
    /**
     * 创建服务数据中转站。 Javascript TranslatoR 组件 JTR 跨域 Ajax 请求(Cross Domain Ajax)
     * @param {String}transferStationId 数据中转站 的 ID
     * @param {String}domain 跨域的域名
     * @param {String}path 跨域文件所在路径
     */
    init: function(transferStationId, domain, path) {
      var self = this;
      var waitingQueue = [];
      var onTransferStationReady = function(sendRequest) {
        self.ajax = sendRequest;
        // 处理队列中正在等待发送的数据  处理请求队列，依次发送请求
        while (waitingQueue.length > 0) {
          sendRequest(waitingQueue.pop());
        }
      };
      if (!!window.postMessage) {
        this.createMessageChannel(transferStationId, domain, path, onTransferStationReady);
      } else {
        this.createJTRAssist(transferStationId, onTransferStationReady);
      }

      this.ajax = function(request) {
        waitingQueue.push(request);
        return this;
      };
      return this;
    },
    /**
     * 创建消息通道
     * @param transferStationId 中转站ID，即 iframe 的 ID
     * @param domain 翻译服务域
     * @param path   iframe 的页面地址
     */
    createMessageChannel:function(transferStationId, domain, path, onTransferStationReady) {
      var self = this;
      /**
       * 创建服务数据中转站，跨域所用 iframe，src 指向项目文件：conn.html
       * conn.html 与翻译服务器同域
       * 此 iframe 的 src 的域一般与本域所需服务所在的域同域
       */
      var transferStation = (function() {
        if (J.isDOM(J.query('#' + transferStationId))) {//保证不出现相同 id 的 iframe
          throw new Error('Existed CDA iFrame element');
        }
        if (domain && path) {//必须提供合法的域名和路径名
          var conn = document.createElement('iframe');
          conn.setAttribute('id', transferStationId);
          conn.className = ('OUTFOX_JTR_CONN');
          conn.style.display = 'none';
          conn.setAttribute('src', domain + path);
          document.body.appendChild(conn);
          return conn.contentWindow;
        } else {
          throw new Error('Empty domain is not allowed');
        }
      })();

      /**
       * 所有请求的处理函数，请求的处理函数与 data.type 属性值应保持一致
       * message 事件监听函数，监听跨域 iframe 回传的数据，触发回调函数
       * @method handleMessage
       * @param {Event}event
       */
      var handleMessage = (function() {
        var callbackQueue = [];
        var callCount = 0;
        var handlers = {
          /**
           * 当服务端iframe加载完毕后，会自动发起此消息，调用 ready 事件
           * 这时，会重定义 ajax 函数为 sendMessage
           */
          'transferStationReady':function() {
            onTransferStationReady(function(request) {
              request.data = J.param(request.data);
              // 记录当前 request 的 index，保证 callback 函数的正确调用
              request.index = callCount++;
              // 将本 request 对应返回数据的类型和回调按照索引缓存，在 handleMessage 中使用
              callbackQueue[request.index] = {
                dataType: request.dataType,
                callback: request.callback
              };
              delete request.callback;

              // 已准备好跨域通信，直接发送数据
              transferStation.postMessage(JSONDAO.stringify(request), domain);
              return self;
            });
          },
          'dataBack':function(data) {
            // 返回数据，处理
            if (!!data && !!callbackQueue[data.index]) {
              var request = callbackQueue[data.index];
              if (J.isFunction(request.callback)) {
                request.callback(J.parseData(request.dataType, data.response));
              }
              delete callbackQueue[data.index];
            }
          }
        };
        return function(event) {
          // 判断是否是自己的 iframe 触发的 message 事件
          if (event.origin !== domain) {
            return;
          }
          // 解析 iframe 回传的数据
          var response = JSONDAO.parse(event.data);
          handlers[response.handler](JSONDAO.parse(event.data));
        };
      })();

      /**
       * 监听并接收 server 端消息，根据 handler 的类型分别处理
       */
      J.bind(window, 'message', function(event) {
        handleMessage.call(self, event);
      });
    },
    /**
     *  创建 JTR 辅助 flash 对象 用以完成跨域请求和跨域本地存储的功能
     *  对于不支持 postMessage 的 IE6、IE7 使用
     */
    createJTRAssist : function(transferStationId, onTransferStationReady) {
      var self = this;
      var swfUrl = '@HOST@/JTRAssist.swf?'+(+new Date());
      /**
       * 创建辅助 flash 对象，加载到页面上。
       * TODO：加载位置需要调整，以后关于JTR的所有资源最好加载到一个节点下面，方便销毁。
       * TODO：有待详细的控制各浏览器各版本object的生成
       */
      var createAssist = function() {
        if (!!J.query('#' + transferStationId)) {
          return;
        }
        var content = document.createElement('div');
        if (J.browser.msie === '6.0' || J.browser.msie === '7.0') {
          content.innerHTML = '<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" width="1" height="1" id="' + transferStationId + '">' +
            '<param name="allowScriptAccess" value="always" />' +
            '<param name="movie" value="' + swfUrl + '" />' +
            '</object>';
        } else {
          content.innerHTML = '<object height="1" width="1" id="' + transferStationId + '" data="' + swfUrl + '">' +
            '<param name="allowScriptAccess" value="always">' +
            '</object>';
        }
        document.body.appendChild(content);
      };

      var callbackIdPre = 'outfox_jtr_fproxy_callback_',
        callbackIndex = 0;
      /**
       * 从服务端加载数据
       * @param param 同 ajax 方法参数格式
       */
      var loadDataFromServer = function(param) {
        var callbackId = callbackIdPre + (callbackIndex++);
        window[callbackId] = function(data) {
          param.callback.call(self, J.parseData(param.dataType, decodeURI(data)));
        };
        J.query('#' + transferStationId).load(param.url, param.data, param.type || 'POST', 'window["' + callbackId + '"]');
      };
      /**
       * 从 flash 本地存储获取数据
       */
      var loadDataFromLocal = function(params) {
        var key = params.data.key,
          value = params.data.value;
        if (value === undefined) {
          if (J.isFunction(params.callback)) {
            params.callback(J.parseData(params.dataType, J.query('#' + transferStationId).getItem(key)));
          }
        } else {
          J.query('#' + transferStationId).setItem(key, value);
        }
      };

      createAssist();
      /**
       * flash 加载完毕后自动执行，需要在flash中调用，所以方法要暴露在window下
       */
      window.JTRAssistIsReady = function() {
        onTransferStationReady(function(param) {
          switch (param.handler) {
            case 'translate':
              param.data = J.param(param.data);
              loadDataFromServer(param);
              break;
            case 'localStorage':
              loadDataFromLocal(param);
              break;
            default:
              throw new Error('Unsupported request type :' + param.handler);
          }
          return self;
        });
      };
    }
  };
  CrossDomainAjax.prototype.init.prototype = CrossDomainAjax.prototype;

  J.CDA = CrossDomainAjax;
})(J);
/**
 * 有道翻译助手
 *
 * @module JTR
 * @submodule TR
 * @author zhangyc
 * @requires J, Page
 */


(function(J) {
  /**
   * TR(TranslatoR) 对象
   * 负责调用 CDA 去请求难词提示和全文翻译信息
   * 并通过 NodeManager 来处理 DOM 节点
   *
   * @class TR
   * @namespace outfox.translate.JTR
   * @constructor
   * @param {Object}context 需要翻译的 DOM 元素
   * @param {Object}config TR 的初始化配置
   * <ul>
   *  <li>reqSize: 每次发送数据包的大小，默认为 10,</li>
   *  <li>onStatusChange: 翻译状态改变的回调函数,</li>
   *  <li>jtrURL: 翻译服务器 URL,</li>
   *  <li>guid: TR 的唯一 ID</li>
   * </ul>
   * @param {Object}conn 支持跨域的通讯接口，需要实现 ajax 方法
   *
   */
  TR = function(context, config, conn, manager) {
    this._manager = manager;
    this._reqSize = config.reqSize;
    this._onStatusChange = config.onStatusChange || function() {
      };
    this._url = config.url;
    this.conn = conn;
    this._context = context;
    this._request = function(url, data, callback) {
      conn.ajax({
        url: url,
        handler:'translate',
        type: 'POST',
        data: data,
        callback: callback,
        dataType: 'json'
      });
    };

    var page = new J.Page(context);
    var textNodes = [];
    var mainArticle = page.getMainArticle();
    if (mainArticle) {
      textNodes = J.getTextNodes(mainArticle.elem, TR.isInclude);
    }

    this.mainNodeLength = textNodes.length || null;

    this._nodeIndex = [];
    textNodes = textNodes.concat(J.getTextNodes(context, function(node) {
      return (node !== (mainArticle && mainArticle.elem)) && TR.isInclude(node);
    }));

    J.each(textNodes, function(index, node) {
      this._nodeIndex.push(this._manager.addNode(node));
    }, this);

    this.workingThread = 0;

    this.guid = config.guid || J.guid();
  };

  TR.prototype = {
    /**
     * 进行全文翻译
     *
     * @method doTrans
     */
    'doTrans': function() {
      var threadId = ++this.workingThread;

      var toSend = {
        //'type': 'EN2ZH_CN', 改由后端判断翻译类别
        'ue': J.getDocumentCharset() || null,
        'data': null,
        'relatedUrl': document.location.href,
        'guid': this.guid,
        'mainLength': this.mainNodeLength,
        'requestId': J.guid()
      };

      var dataArray = [];
      var count = 0;
      for (var index = 0; index < this._nodeIndex.length; index++) {
        if (this._manager.transResults[index]) {
          if (threadId === this.workingThread) {
            this._manager.replaceTrans(index);
          }
        } else {
          var data = null;
          if (dataArray[parseInt(count / this._reqSize, 10)]) {
            data = dataArray[parseInt(count++ / this._reqSize, 10)];
          } else {
            data = dataArray[parseInt(count++ / this._reqSize, 10)] = {};
          }

          var parent = null;
          try {
            parent = this._manager.nodes[index].parentNode && this._manager.nodes[index].parentNode.tagName || null;
          } catch(exp) {

          }

          data[index] = {
            'src': this._manager.originals[index],
            'tag': parent
          };
        }
      }

      if (dataArray.length === 0) {
        this._onStatusChange({
          id: threadId,
          action: 'TRANS',
          level: '0',
          status: 'finish'
        });
        return;
      }

      var self = this,
        tempRequest = function(index) {
          //J.log('Send:', dataArray[index]);
          self._onStatusChange({
            id: threadId,
            action: 'TRANS',
            level: '0',
            status: 'busy',
            data: [index, dataArray.length]
          });
          toSend.data = JSONDAO.stringify(dataArray[index]);
          self._request(self._url.textTrans, toSend, function(data) {
            self._updateTrans(data, threadId);
            if (++index < dataArray.length) {
              tempRequest(index);
            } else {
              self._onStatusChange({
                id: threadId,
                action: 'TRANS',
                level: '0',
                status: 'finish'
              });
            }
          });
        };

      tempRequest(0);
    },

    /**
     * 取消全文翻译结果
     *
     * @method revertTrans
     */
    'revertTrans': function() {
      var threadId = ++this.workingThread;
      for (var i = 0; i < this._nodeIndex.length; i++) {
        if (threadId === this.workingThread) {
          this._manager.revertTrans(this._nodeIndex[i]);
        }
      }
    },

    /**
     * 分析服务器返回的全文翻译数据，写入翻译结果到 NodeManager
     *
     * @method _updateTrans
     * @private
     * @param {Object}transResultData
     * @param {Number}threadId
     */
    '_updateTrans': function(transResultData, threadId) {
      if (!!!transResultData) {
        return;
      }
      if (transResultData.errorCode === 40 && transResultData.errorCode === 30) {
        J.log('Get Error Code:', transResultData.errorCode);
        return;
      }

      J.each(transResultData.data, function(index, data) {
        this._manager.transResults[index] = data.tst;
        if (threadId === this.workingThread) {
          this._manager.replaceTrans(index);
        }
      }, this);
    },

    /**
     * 进行难词提示
     *
     * @method doTips
     * @param {Number}level 难词提示等级
     */
    doTips: function(level) {
      var threadId = ++this.workingThread;

      var toSend = {
        'type': 'X',
        'ue': J.getDocumentCharset() || null,
        'data': null,
        'relatedUrl': document.location.href,
        'mainLength': this.mainNodeLength,
        'guid': this.guid
      };

      var dataArray = [];
      var count = 0;
      for (var index = 0; index < this._nodeIndex.length; index++) {
        if (this._manager.tipsResults[index]) {
          if (threadId === this.workingThread) {
            this._manager.replaceTips(index, level);
          }
        } else {
          var data = null;
          if (dataArray[parseInt(count / this._reqSize, 10)]) {
            data = dataArray[parseInt(count++ / this._reqSize, 10)];
          } else {
            data = dataArray[parseInt(count++ / this._reqSize, 10)] = {};
          }

          var parent = null;
          try {
            parent = this._manager.nodes[index].parentNode && this._manager.nodes[index].parentNode.tagName || null;
          } catch(exp) {

          }

          data[index] = {
            'src': this._manager.originals[index],
            'tag': parent
          };
        }
      }

      if (dataArray.length === 0) {
        this._onStatusChange({
          id: threadId,
          action: 'TIPS',
          level: level,
          status: 'finish'
        });
        return;
      }

      var self = this;
      var tempRequest = function(index) {
        J.log('Send:', dataArray[index]);
        self._onStatusChange({
          id: threadId,
          action: 'TIPS',
          level: level,
          data: [index, dataArray.length],
          status: 'busy'
        });
        toSend.data = JSONDAO.stringify(dataArray[index]);
        self._request(self._url.tips, toSend, function(data) {
          self._updateTips(data, threadId, level);
          if (++index < dataArray.length) {
            tempRequest(index);
          } else {
            self._onStatusChange({
              id: threadId,
              action: 'TIPS',
              level: level,
              status: 'finish'
            });
          }
        });
      };

      tempRequest(0);
    },

    /**
     * 取消难词提示结果
     *
     * @method revertTips
     */
    revertTips: function() {
      var threadId = ++this.workingThread;
      for (var i = 0; i < this._nodeIndex.length; i++) {
        if (threadId === this.workingThread) {
          this._manager.revertTips(this._nodeIndex[i]);
        }
      }
    },

    /**
     * 获取服务器返回的难词提示数据，将结果写入 nodeManager
     *
     * @method _updateTips
     * @private
     * @param {Object}tipsResultData
     * @param {Number}threadId
     * @param {Number}level
     */
    _updateTips: function(tipsResultData, threadId, level) {
      if (!!!tipsResultData) {
        return;
      }

      if (tipsResultData.errorCode === 40 && tipsResultData.errorCode === 30) {
        J.log('Get Error Code:', tipsResultData.errorCode);
        return;
      }

      var _cmp = function(dataA, dataB) {
        return dataA.start > dataB.start;
      };

      //J.log('Get:', tipsResultData.data);
      J.each(tipsResultData.data, function(index, data) {
        if (data.length > 0) {
          this._bubbleSort(data, _cmp);
          this._manager.tipsResults[index] = data;
          if (threadId === this.workingThread) {
            this._manager.replaceTips(index, level);
          }
        } else {
          this._manager.tipsResults[index] = [];
        }
      }, this);
    },

    /**
     * 冒泡排序
     *
     * @method _bubbleSort
     * @private
     * @param {Array}inputArray
     * @param {Function}cmp
     */
    _bubbleSort: function(inputArray, cmp) {
      for (var i = inputArray.length - 2; i >= 0; i--) {
        for (var j = 0; j <= i; j++) {
          if (cmp(inputArray[j + 1], inputArray[j])) {
            var tempValue = inputArray[j];
            inputArray[j] = inputArray[j + 1];
            inputArray[j + 1] = tempValue;
          }
        }
      }
      return inputArray;
    }
  };

  /**
   * DOM 元素过滤条件
   * 元素为非script、style、pre、并且不是JTR创建的元素
   * @method isInclude
   * @param {DOMNode}node  当前遍历到的元素节点
   * @return {Boolean}
   */
  TR.isInclude = function(node) {
    return !(node.tagName === 'SCRIPT' || node.tagName === 'STYLE' || node.tagName === 'PRE' || (node.className && node.className.indexOf('OUTFOX_JTR_') !== -1));
  };

  J.TR = TR;
})(J);

/**
 * Youdao Dict Swipe extension
 *
 * @author dongxu, zhangyc
 * @module Swipe
 * @requires J CDA
 */

if (!J || ! J.bind) {
  throw new Error('swipe extension need J.bind support');
}

(function(J) {
  var  BASE_HOST = '@FANYI_HOST@',
    DICT_URL = BASE_HOST + '/fsearch',
    TRANS_URL = BASE_HOST + '/translate';
  /**
   * 发音插件
   * @param word
   */
  var insertAudio = function(word) {
    return '<object classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=7,0,0,0" width="15px" height="15px" align="absmiddle" id="speach_flash">' + '<param name="allowScriptAccess" value="sameDomain" />' + '<param name="movie" value="http://cidian.youdao.com/chromeplus/voice.swf" />' + '<param name="loop" value="false" />' + '<param name="menu" value="false" />' + '<param name="quality" value="high" />' + '<param name="wmode"  value="transparent">' + '<param name="FlashVars" value="audio=' + word + '">' + '<embed wmode="transparent" play="false" src="http://cidian.youdao.com/chromeplus/voice.swf" loop="false" menu="false" quality="high" bgcolor="#ffffff" width="15" height="15" align="absmiddle" allowScriptAccess="sameDomain" FlashVars="audio=' + word + '" type="application/x-shockwave-flash" pluginspage="http://www.macromedia.com/go/getflashplayer" />' + '</object>';
  };
  /**
   * 单词个数
   * @param str
   */
  var spaceCount = function(str) {
    return str.split && str.split(' ').length || 0;
  };
  /**
   * Language detect utility
   * 判断语种类型
   * @class Lang
   * @namespace outfox.translate.JTR
   */
  var Lang = {
    isJapanese: function(temp) {
      return ! Boolean(/[^\u0800-\u4e00]/.test(temp));
    },

    isContainJapanese: function(temp) {
      var cnt = 0;
      for (var i = 0; i < temp.length; i++) {
        if (this.isJapanese(temp.charAt(i))) {
          cnt++;
        }
      }
      return cnt > 2;
    },

    isKoera: function(str) {
      for (i = 0; i < str.length; i++) {
        if (((str.charCodeAt(i) > 0x3130 && str.charCodeAt(i) < 0x318F) || (str.charCodeAt(i) >= 0xAC00 && str.charCodeAt(i) <= 0xD7A3))) {
          return true;
        }
      }
      return false;
    },

    isContainKoera: function(temp) {
      var cnt = 0;
      for (var i = 0; i < temp.length; i++) {
        if (this.isKoera(temp.charAt(i))) {
          cnt++;
        }
      }
      return cnt > 0;
    },

    isChinese: function(temp) {
      return ! Boolean(/[^\u4e00-\u9fa5]/.test(temp));
    },

    isContainChinese: function(temp) {
      var cnt = 0;
      for (var i = 0; i < temp.length; i++) {
        if (this.isChinese(temp.charAt(i))) {
          cnt++;
        }
      }
      return cnt > 5;
    }
  };

  /**
   * Swipe class
   *
   * @class Swipe
   * @namespace outfox.translate.JTR
   * @constructor
   * @param {DOMNode}context 使用划词翻译的 DOM 根节点
   * @param {CDA}conn 跨域通讯接口
   * @return {Swipe}
   */
  var Swipe = function(context, conn) {
    return new Swipe.fn.init(context, conn);
  };

  Swipe.fn = Swipe.prototype = {
    init: function(context, conn) {
      var self = this;
      this.wrapper = Swipe.createFrameWrapper();
      this.conn = Swipe.initConnection(conn);
      this.context = context;

      // listen body click event to hide frame wrapper
      J.bind(document.body, 'click', function(e) {
        var evt = e || window.event;

        // clean frame wrapper content
        self.wrapper.style.display = 'none';
        self.wrapper.style.position = 'absolute';
        self.wrapper.innerHTML = '';
      });
    },

    enableSwipe: function() {
      if (!this._swipeListener) {
        var self = this;
        this._swipeListener = function(evt) {
          self._onSwipe.call(self, evt);
        };

        J.bind(this.context, 'mouseup', this._swipeListener);
      }
    },

    disableSwipe: function() {
      if (this._swipeListener) {
        J.unbind(this.context, 'mouseup', this._swipeListener);
        delete this._swipeListener;
      }
    },

    /**
     * User swipe event listener.
     * Get the user selected text, and validate it. If it can be translated, do a translate request and set the callback.
     *
     * @method _onSwipe
     * @param {Event}evt
     */
    _onSwipe: function(evt) {
      var userSelection = '',
        word = '';
      var range = {};
      if (window.getSelection) {
        userSelection = window.getSelection();
      } else if (document.selection) {
        userSelection = document.selection.createRange();
      }
      if (userSelection.toString) {
        word = userSelection.toString();
      } else if (userSelection.text) {
        word = userSelection.text.toString();
      }
      var pos = J.textPos(evt,{});
      word = J.trim(word);
      if (!Swipe.validateSwipeWord(word)) {
        return;
      }
      this.swipeWord(word, pos.x, pos.y);
      if (this.onSwipeCallback) {
        this.onSwipeCallback(word);
      }
    },

    swipeWord: function(word, x, y, offsetLeft, offsetTop) {
      var self = this;
      // Decide which type will request to the server, word or sentance
      var type = null;
      this.wrapper.innerHTML = '';
      if ((!Lang.isContainChinese(word) && spaceCount(word) >= 3) || (Lang.isContainChinese(word) || Lang.isContainJapanese(word) && word.length > 4)) {
        type = 'translate';
      } else {
        type = 'dict';
      }

      this.conn.request({
        action: type,
        word: word
      }, function(data) {
        self.wrapper.innerHTML = '';
        self._onResponse.call(self, data);
        Swipe.initWrapper(self.wrapper, x, y, offsetLeft, offsetTop);
      });
    },

    // Data back event listener
    _onResponse: function(data) {
      var $root = data.firstChild,
        $elem = null;

      if (!$root) {
        return;
      } else if ($root.baseName && $root.baseName == 'xml') {
        $root = $root.nextSibling;
      }

      switch ($root.tagName) {
        case 'response':
          $elem = Swipe.processXmlTransData(data);
          break;
        case 'yodaodict':
          $elem = Swipe.processXmlDictData(data);
          break;
        default:
          throw new Error('Incorrect xml data');
      }

      if ($elem) {
        this.wrapper.appendChild($elem);
        this.wrapper.style.display = 'block';
      }
    }
  };

  /**
   * Create frame wrapper, and cancel click event bubble
   *
   * @method createFrameWrapper
   * @static
   * @return {DOMNode}
   */
  Swipe.createFrameWrapper = function() {
    var frame = document.createElement('div');
    frame.id = 'yddWrapper';
    J.bind(frame, 'click', function(e) {
      J.stopPropagation(e);
    });
    J.bind(frame, 'mouseup', function(e) {
      J.stopPropagation(e);
    });
    document.body.appendChild(frame);
    return frame;
  };

  /**
   * validate user select string
   *
   * @method validateSwipeWord
   * @static
   * @param {String}word
   * @return {String}
   */
  Swipe.validateSwipeWord = function(word) {
    return !(word === '' || word.length > 2000);
  };

  /**
   * Initialize cross-domain connection port
   * 初始化跨域连接端口
   *
   * @method initConnection
   * @static
   */
  Swipe.initConnection = function(connector) {
    var conn = null;
    var _parseRequest = function(data) {
      var url = null, param = null;
      if (data.action == 'dict') {
        param = {
          client: 'JTRHelper',
          keyfrom: 'JTRHelper.bookmark',
          q: data.word,
          pos: -1,
          doctype: 'xml',
          xmlVersion: '3.2',
          dogVersion: '1.0',
          vendor: 'jtr',
          le: 'eng'
        };
        url = DICT_URL;
      } else {
        param = {
          client: 'JTRHelper',
          keyfrom: 'JTRHelper.bookmark',
          i: data.word,
          doctype: 'xml',
          xmlVersion: '1.1',
          dogVersion: '1.0'
        };
        url = TRANS_URL;
      }
      return [url, param];
    };
    if (window.chrome && window.chrome.extension && window.chrome.extension.sendRequest) {
      //prepare connection using chrome extension
      conn = {
        'request': function(data, callback) {
          window.chrome.extension.sendRequest(data, function(response) {
            if (response) {
              callback((new DOMParser()).parseFromString(response, "text/xml"));
            }
          });
        }
      };

      return conn;
    } else if (connector) {
      conn = {
        'request': function(data, callback) {
          var parsed = _parseRequest(data);
          connector.ajax({
            url: parsed[0],
            handler:'translate',
            data: parsed[1],
            callback: callback,
            dataType: 'xml',
            type: 'POST'
          });
        }
      };
      return conn;
    } else if (J.CDA) {
      //prepare connection using Cross-Domain Ajax
      var cda = null;
      try {
        cda = J.CDA('_OUTFOX_JTR_SWIPE_CONN', BASE_HOST, CONN_FILE_PATH);
      } catch(e) {
        throw new Error('Unable to get cross-domain ajax file.');
      }

      conn = {
        'request': function(data, callback) {
          var parsed = _parseRequest(data);
          cda.ajax({
            url: parsed[0],
            handler:'translate',
            data: parsed[1],
            callback: callback,
            dataType: 'xml',
            type: 'POST'
          });
        }
      };

      return conn;
    } else {
      throw new Error('Unable to initialize cross-domain connection port.');
    }
  };

  /**
   * Change wrapper position and show it
   *
   * @method initWrapper
   * @static
   * @param {DOMNode}wrapper
   * @param {Event}evt
   */
  Swipe.initWrapper = function(wrapper, x, y, offsetLeft, offsetTop) {
    var left = 0,
      top = 0,
      barHeight = 50,
      scrollTop = J.scroll().top,
      scrollLeft = J.scroll().left,
      tipHeight = wrapper.clientHeight,
      tipWidth = wrapper.clientWidth,
      bodyHeight = J.getPageSize().window.height,
      bodyWidth = J.getPageSize().window.width;


    offsetLeft = offsetLeft || 0;
    offsetTop = offsetTop || 0;

    if (y - tipHeight >= scrollTop + barHeight) {
      top = y - tipHeight;
    } else {
      top = y + offsetTop;
    }

    if (x + tipWidth <= bodyWidth + scrollLeft) {
      left = x + offsetLeft;
    } else {
      left = bodyWidth + scrollLeft - tipWidth;
    }

    //body 非静态定位时，消除 margin 的影响
    var isBodyPositioned = !!(J.css(document.body, 'position') !== 'static');
    var marginLeft = J.css(document.body, 'marginLeft');
    var marginRight = J.css(document.body, 'marginRight');
    //处理 margin 是 auto 时，marginLeft无法正确计算的问题
    if (marginLeft === 'auto' && marginRight === 'auto') {
      var pageWidth = J.getPageSize().page.width;
      var bodyCWidth = parseInt(J.css(document.body, 'width'));
      if (pageWidth > bodyCWidth) {
        marginLeft = (pageWidth - bodyCWidth) / 2;
      } else {
        marginLeft = 0;
      }
    }
    marginLeft = isBodyPositioned ? parseInt(marginLeft) : 0;

    var marginTop = isBodyPositioned ? parseInt(J.css(document.body, 'marginTop')) : 0;
    J.css(wrapper, {
      position:'absolute',
      left : (left - marginLeft) + 'px',
      top: (top - marginTop) + 'px'
    });
  };

  /**
   * Convert trans result(XML data format) to HTML element
   *
   * @method processTransDictData
   * @static
   * @param {XMLNode}$root
   * @return {DOMNode}
   */
  Swipe.processXmlTransData = function($root) {
    var inputStr = ($root.getElementsByTagName('input')[0].childNodes[1] || $root.getElementsByTagName('input')[0].childNodes[0]).nodeValue,
      transStr = ($root.getElementsByTagName('translation')[0].childNodes[1] || $root.getElementsByTagName('translation')[0].childNodes[0]).nodeValue,
      errorCode = $root.getElementsByTagName('response')[0].getAttribute('errorCode') - 0,

      transStrTrimed = J.trim(transStr),
      inputStrTrimed = J.trim(inputStr);

    if ((Lang.isContainChinese(inputStrTrimed) || Lang.isContainJapanese(inputStrTrimed) || Lang.isContainKoera(inputStrTrimed)) && inputStrTrimed.length > 15) {
      inputStrTrimed = inputStrTrimed.substring(0, 8) + ' ...';
    } else if (inputStrTrimed.length > 25) {
      inputStrTrimed = inputStrTrimed.substring(0, 15) + ' ...';
    }

    if (inputStrTrimed == transStrTrimed) {
      return null;
    }

    var searchURL = 'http://fanyi.youdao.com/translate?i=' + encodeURIComponent(inputStr) + '&keyfrom=chrome';
    var TEMPLATE = '<div class="ydd-container">\
                          <div class="ydd-top-wrapper">\
                            <div class="ydd-top">\
                            </div>\
                          </div>\
                          <div class="ydd-body-wrapper">\
                            <div class="ydd-lb"></div>\
                            <div class="ydd-rb"></div>\
                            <div class="ydd-body">\
                              <div class="ydd-titile">\
                                <span>{input}</span>\
                                <span><a href="{searchURL}" target="_blank">详细&rsaquo;&rsaquo;</a></span>\
                              </div>\
                              <div class="ydd-middle">\
                                <div class="ydd-trans-wrapper ydd-simple-trans">\
                                  <div class="ydd-trans-container">{trans}</div>\
                                </div>\
                              </div>\
                            </div>\
                          </div>\
                          <div class="ydd-bottom-wrapper"><div class="ydd-bottom"></div></div>\
                          <div class="ydd-bg-top"></div></div>\
                        </div>';

    return J.formatTemplate(TEMPLATE, {
      searchURL: searchURL,
      input: Swipe.escapeHTML(inputStrTrimed),
      trans: Swipe.escapeHTML(transStr)
    });
  };

  /**
   * Convert dict result(XML data format) to HTML element
   *
   * @method processXmlDictData
   * @static
   * @param {XMLNode}$root
   * @return {DOMNode}
   */
  Swipe.processXmlDictData = function($root) {
    var $webTrans = null,
      $baseTrans = null,
      baseTrans = [],
      webTrans = [],
      word = '',
      speech = '',
      lang = '',
      phonetic = '',
      i = 0;
    var getValueFrom = function(node) {
      try {
        return $root.getElementsByTagName(node)[0].firstChild.nodeValue;
      } catch(err) {
        return '';
      }
    };
    word = getValueFrom('return-phrase');
    speech = getValueFrom('dictcn-speach');
    lang = getValueFrom('lang');
    phonetic = getValueFrom('phonetic-symbol');

    if (($baseTrans = $root.getElementsByTagName("translation")) && $baseTrans.length > 0) {
      for (i = 0; i < $baseTrans.length; i++) {
        baseTrans.push($baseTrans[i].getElementsByTagName("content")[0].firstChild.nodeValue);
      }
    }

    if (($webTrans = $root.getElementsByTagName('web-translation')) && $webTrans.length > 0) {
      for (i = 0; i < $webTrans.length - 1; i++) {
        webTrans.push({
          key: $webTrans[i].getElementsByTagName('key')[0].firstChild.nodeValue,
          value: $webTrans[i].getElementsByTagName('trans')[0].getElementsByTagName('value')[0].firstChild.nodeValue
        });
      }
    }
    // start to package HTML element
    var searchURL = 'http://dict.youdao.com/search?q=' + encodeURIComponent(word) + '&keyfrom=chrome.extension' + lang,
      title = word,
      speechHTML = '',
      baseTransHTML = '',
      webTransHTML = '',
      $result = null,
      FANYI_URL = 'http://www.youdao.com/search?q={title}&keyfrom=fanyi.jtr',
      TEMPLATE = '';
    TEMPLATE = '<div class="ydd-container">\
                      <div class="ydd-top-wrapper">\
                        <div class="ydd-top"></div>\
                      </div>\
                      <div class="ydd-body-wrapper">\
                        <div class="ydd-lb"></div>\
                        <div class="ydd-rb"></div>\
                        <div class="ydd-body">\
                          <div class="ydd-titile">\
                            <span class="ydd-key-title">{title}</span>\
                            <span class="ydd-phonetic">{phonetic}</span> {speechHTML} <span class="ydd-detail"><a href="{searchURL}" target="_blank">详细&rsaquo;&rsaquo;</a></span>\
                          </div>\
                          <div class="ydd-middle">\
                            <div class="ydd-trans-wrapper ydd-base-trans">\
                              <div class="ydd-tabs"><span class="ydd-tab">基本翻译</span></div>{baseTransHTML}</div>\
                              <div class="ydd-trans-wrapper ydd-web-trans">\
                                <div class="ydd-tabs"><span class="ydd-tab">网络释义</span></div>{webTransHTML}</div>\
                              </div>\
                            </div>\
                          </div>\
                        <div class="ydd-bottom-wrapper">\
                          <div class="ydd-bottom"><a href="' + FANYI_URL + '" target="_blank" title="使用有道搜索 {title}">搜索&nbsp;{title}</a></div>\
                        </div>\
                        <div class="ydd-bg-top"></div>\
                      </div>\
                    </div>';

    //substring word to title
    if ((Lang.isContainChinese(title) || Lang.isContainJapanese(title) || Lang.isContainKoera(title)) && title.length > 15) {
      title = title.substring(0, 10) + '...';
    } else if (title.length > 25) {
      title = title.substring(0, 15) + ' ...';
    }

    if (baseTrans.length + webTrans.length > 0 && speech) {
      speechHTML = '<span class="ydd-voice">' + insertAudio("http://dict.youdao.com/speech?audio=" + speech, "test", "CLICK", "dictcn_speech") + '</span>';
    }

    for (i = 0; i < baseTrans.length; i++) {
      baseTransHTML += '<div class="ydd-trans-container">' + baseTrans[i] + '</div>';
    }

    for (i = 0; i < webTrans.length; i++) {
      var webTransURL = 'http://dict.youdao.com/search?q=' + encodeURIComponent(webTrans[i].key) + '&keyfrom=chrome.extension' + lang;
      webTransHTML += '<div class="ydd-trans-container"><a href="' + webTransURL + '" target="_blank">' + webTrans[i].key + ":</a> " + webTrans[i].value + '</div>';
    }

    $result = J.formatTemplate(TEMPLATE, {
      phonetic: phonetic ? '[' + phonetic + ']' : '',
      title: title,
      searchURL: searchURL,
      speechHTML: speechHTML,
      baseTransHTML: baseTransHTML,
      webTransHTML: webTransHTML
    });
    var $middle = J.query('.ydd-middle',$result)[0];
    $baseTrans = J.query('.ydd-base-trans',$middle)[0];
    $webTrans = J.query('.ydd-web-trans',$middle)[0];

    if (baseTrans.length + webTrans.length === 0) {
      $middle.innerHTML = '<p class="ydd-no-result">没有英汉互译结果</p>';
    }

    try {
      if (baseTrans.length === 0) {
        $middle.removeChild($baseTrans);
      } else if (webTrans.length === 0) {
        $middle.removeChild($webTrans);
      }
    } catch(e) {
    }
    return $result;
  };

  var entityMap = {
    "&": "&amp;",
    "<": "&lt;",
    ">": "&gt;",
    '"': '&quot;',
    "'": '&#39;',
    "/": '&#x2F;'
  };

  /**
   * HTML的转义以便减少XSS风险.
   * http://stackoverflow.com/questions/24816/escaping-html-strings-with-jquery
   */
  Swipe.escapeHTML = function(string) {
    return String(string).replace(/[&<>"'\/]/g, function (s) {
      return entityMap[s];
    });
  };

  Swipe.fn.init.prototype = Swipe.fn;
  J.Swipe = Swipe;
})(J);
/**
 * 滑动条模块
 *
 * @module J
 * @submodule Slider
 * @author zhangyc
 * @requires J
 */

(function(J) {
  /**
   * Javascript TranslatoR 组件 JTR UI 的 Slider 控件
   *
   * @class Slider
   * @namespace outfox.translate.JTR
   * @constructor
   * @param {DOMNode}container
   * @param {DOMNode}controller
   * @param {Object}config
   * <ul>
   * <li>config.bar {DOMNode} 背景填充条</li>
   * <li>config.max {Number} 最大值</li>
   * <li>config.min {Number} 最小值</li>
   * <li>config.callback {Function} 值发生改变时的回调函数</li>
   * <li>config.borderFix {Number} 两侧的像素修正</li>
   * </ul>
   */
  var Slider = function(container, controller, config) {
    var self = this;

    if (!J.isDOM(container)) {
      throw Error('Invalid slider container element');
    }

    this.container = container;

    if (!J.isDOM(controller)) {
      throw Error('Invalid slider controller block element');
    }

    this.controller = controller;

    for (var doc = this.container; doc; doc = doc.parentNode) {
      if (doc.nodeType === 9) {
        this.document = doc;
        break;
      }
    }

    if (!doc) {
      throw Error('Can\'t find parent Document element of container, container dom node should insert to document first');
    }

    if (J.isDOM(config.bar)) {
      this.bar = config.bar;
    } else {
      this.bar = null;
    }

    this.range = Number(config.max - config.min);
    if (!(this.range && this.range > 0)) {
      throw Error('range must greater than 0');
    }

    if (J.isFunction(config.callback)) {
      this.callback = function(data) {
        config.callback.call(self, data);
      };
    }

    this.borderFix = Number(config.borderFix) || 0;

    this.mousemove = function(evt) {
      self._mousemove(evt);
    };
    this.mouseup = function(evt) {
      self._mouseup(evt);
    };
    this.mousedown = function(evt) {
      self._mousedown(evt);
    };
  };

  Slider.prototype = {
    enable: function() {
      J.bind(this.container, 'mousedown', this.mousedown);
    },
    disable: function() {
      J.unbind(this.container, 'mousedown', this.mousedown);
    },

    to: function(value, force) {
      var self = this,
        timer = null;
      tempFunc = function() {
        if (!self.container.offsetHeight || !self.container.clientWidth) { //防止 css 样式没有加载完成时移动slider
          timer = setTimeout(tempFunc, 200);
          return;
        }
        var fullWidth = self.container.clientWidth - self.controller.clientWidth - 2 * self.borderFix;
        pos = value / self.range * fullWidth;

        self._valueChange(pos / fullWidth * self.range, pos);
      };

      tempFunc();
    },

    _mousemove: function(e) {
      var evt = e || window.event;
      this._moveHandler(evt, false);
    },

    _mouseup: function(e) {
      var evt = e || window.event;
      this._moveHandler(evt, true);

      J.unbind(this.document, 'mouseup', this.mouseup);
      J.unbind(this.document, 'mousemove', this.mousemove);
      this.container.style.cursor = 'pointer';
    },

    _mousedown: function(e) {
      var evt = e || window.event;
      this._moveHandler(evt, false);

      J.bind(this.document, 'mouseup', this.mouseup);
      J.bind(this.document, 'mousemove', this.mousemove);

      // 防止元素被选中引发浏览器拖拽文本
      if (evt.preventDefault) {
        evt.preventDefault();
      }
      evt.returnValue = false;
    },

    _moveHandler: function(event, magnet) {
      var eventOffset = event.clientX - 1 / 2 * this.controller.clientWidth - J.findPos(this.container).x - this.borderFix,
        fullWidth = this.container.clientWidth - this.controller.clientWidth - 2 * this.borderFix,
        stepWidth = fullWidth / this.range,
        stopRange = stepWidth / 2,
        stepOffset = eventOffset % stepWidth, // 距离最近的停靠点的距离
        pos = 0;

      if (eventOffset < 0) {
        eventOffset = 0;
        stepOffset = 0;
      } else if (eventOffset > fullWidth) {
        eventOffset = fullWidth;
        stepOffset = 0;
      }

      if (magnet && stepOffset < stopRange) {
        pos = eventOffset - stepOffset;
      } else if (magnet && stepOffset > stepWidth - stopRange) {
        pos = eventOffset - stepOffset + stepWidth;
      } else {
        pos = eventOffset;
      }

      this._valueChange(pos / fullWidth * this.range, pos);
    },

    _valueChange: function(value, pos) {
      this.callback(value);
      this.controller.style.left = pos + this.borderFix + 'px';
      if (this.bar) {
        this.bar.style.width = pos + this.controller.clientWidth / 2 + 'px';
      }
    }
  };

  J.Slider = Slider;
})(J);

/**
 * DOM 结点存储、处理模块
 *
 * @module JTR
 * @submodule NodeManager
 * @author zhangyc
 * @requires J
 */

(function(J) {
  /**
   * DOM 结点存储、处理对象
   *
   * @class NodeManager
   * @namespace outfox.translate.JTR
   * @constructor
   */
  var NodeManager = function() {
    this.nodes = [];
    this.originals = {};
    this.transResults = {};
    this.tipsResults = {};
  };

  NodeManager.prototype = {
    /**
     * 增加 DOM 元素
     *
     * @method addNode
     * @param {DOMNode}node
     * @param {Boolean}directAdd
     */
    addNode: function(node, directAdd) {
      var index = 0;
      if (!directAdd) {
        for (; index < this.nodes.length; index++) {
          if (this.nodes[index] === node) {
            return index;
          }
        }
      }

      this.nodes.push(node);
      this.originals[index] = node.nodeValue;
      return index;
    },

    /**
     * 使用全文翻译数据替换结点内容
     *
     * @method replaceTrans
     * @param {Number}index 要替换的结点索引
     */
    replaceTrans: function(index) {
      if (this.nodes[index] && this.transResults[index]) {
        var node = this.nodes[index],
          wrapper = document.createElement('font'),
          transResult = this.transResults[index];
        try {
          if (node.nodeValue === transResult) {
            return false;
          }
          if (!node.parentNode) {
            return;
          }
        } catch(exp) {
          return;
        }

        node.nodeValue = '';
        wrapper.className = 'OUTFOX_JTR_TRANS_NODE';
        wrapper.id = 'OUTFOX_JTR_TRANS_NODE-' + index;
        wrapper.setAttribute('rel', index);
        wrapper.innerHTML = transResult;

        try { //todo：ie6 中有问题，暂时只捕捉错误，下一步再找原因
          node.parentNode.insertBefore(wrapper, node.nextSibling);
        } catch(err) {

        }
      }
    },

    /**
     * 取消全文翻译结果
     *
     * @method revertTrans
     * @param {Number}index 要撤销翻译的结点索引
     */
    revertTrans: function(index) {
      if (this.nodes[index] && this.originals[index]) {
        var wrapper = J.query('#OUTFOX_JTR_TRANS_NODE-' + index);
        if (wrapper && wrapper.parentNode) {
          wrapper.parentNode.removeChild(wrapper);
        }
        try {
          this.nodes[index].nodeValue = this.originals[index];
        } catch(exp) {
          // node not existed
        }
      }
    },

    /**
     * 使用难词提示数据替换结点内容
     *
     * @method replaceTips
     * @param {Number}index 要替换的结点索引
     * @param {Number}lvl 难词提示等级
     */
    replaceTips: function(index, lvl) {
      var level = lvl || -1;
      if (this.nodes[index] && this.tipsResults[index]) {
        J.each(this.tipsResults[index], function(temp, data) {
          if (data.level && data.level < level) {
            return;
          }
          var textNode = this.nodes[index],
            start = data.start,
            end = data.end,
            explain = data.explain;
          if (typeof textNode.parentNode === undefined) {
            return;
          }

          var wrapper = document.createElement('font');
          wrapper.className = 'OUTFOX_NANCI_WRAPPER';

          try {//todo:为防止IE中发生不可恢复的错误所加，待找到真正原因后，删除
            var before = textNode.nodeValue.substr(0, start),
              word = textNode.nodeValue.substr(start, end - start),
              after = textNode.nodeValue.substr(end);
            textNode.nodeValue = before;
            wrapper.innerHTML = word;
            textNode.parentNode.insertBefore(document.createTextNode(after), textNode.nextSibling);
            textNode.parentNode.insertBefore(wrapper, textNode.nextSibling);

            var elemAfter = document.createElement('font');
            elemAfter.className = 'OUTFOX_NANCI_TIPS';
            elemAfter.setAttribute('rel', index);
            elemAfter.innerHTML = '(' + explain + ')';
            wrapper.parentNode.insertBefore(elemAfter, wrapper.nextSibling);
          } catch(err) {

          }
        }, this);
      }
    },

    /**
     * 撤销一个结点的所有难词提示结果
     *
     * @method revertTips
     * @param {Number}index 要撤销的结点索引
     */
    revertTips: function(index) {
      if (this.nodes[index]) {
        var empty;
        do{
          try {
            empty = !this.revertTip(this.nodes[index].nextSibling);
          } catch(exp) {
            empty = true;
          }
        } while (!empty);
      }
    },

    /**
     * 撤销一个难词提示结果
     *
     * @method revertTip
     * @param {DOMNode}wrapper 难词的 wrapper 元素
     */
    revertTip: function(wrapper) {
      if (J.hasClass(wrapper, 'OUTFOX_NANCI_WRAPPER') && wrapper.firstChild) {
        var tip = wrapper.nextSibling;
        if (J.hasClass(tip, 'OUTFOX_NANCI_TIPS')) {
          tip.parentNode.removeChild(tip);
        }

        if (wrapper.nextSibling && wrapper.nextSibling.nodeType === 3) {
          wrapper.firstChild.nodeValue += wrapper.nextSibling.nodeValue;
          wrapper.parentNode.removeChild(wrapper.nextSibling);
        }

        if (wrapper.previousSibling && wrapper.previousSibling.nodeType === 3) {
          wrapper.previousSibling.nodeValue += wrapper.firstChild.nodeValue;
          wrapper.parentNode.removeChild(wrapper);
        }

        return true;
      } else {
        return false;
      }
    },

    /**
     * 统计难词提示数量
     *
     * @method countTips
     * @param {Number}level 需要统计的等级
     */
    countTips: function(level) {
      var num = 0;
      J.each(this.tipsResults, function(key, tips) {
        for (var i = 0; i < tips.length; i++) {
          if (tips[i].level >= level) {
            num++;
          }
        }
      }, this);
      return num;
    }
  };

  J.NodeManager = NodeManager;
})(J);

/**
 * 缓存模块，实现简单的 K-V 存储方式
 *
 * @module J
 * @submodule Cache
 */

(function(J) {
  /**
   * 缓存，实现简单的 K-V 存储方式
   * 可以为每一个 object 创建一个 HashMap，用来存储一些数据
   * 比如元素的样式
   *
   * @class Cache
   * @namespace outfox.translate.JTR
   * @constructor
   */
  var Cache = function() {
    /**
     * 元素映射，存储 HashKey - Object
     *
     * @property map
     * @private
     */
    this.map = {};

    /**
     * 数据映射，存储 HashKey - Value
     *
     * @property dataMap
     * @private
     */
    this.dataMap = {};

  };

  Cache.prototype = {
    /**
     * 获取一个元素的 ID (HashID)
     *
     * @method getID
     * @param {Object}obj 作为 key 的任意元素
     * @return {String}
     */
    getId: function(obj) {
      var id = null;
      J.each(this.map, function(mapId, mapObj) {
        if (mapObj === obj) {
          id = mapId;
          return false; //break each
        }
      });

      if (id === null) {
        id = J.guid();
        this.map[id] = obj;
      }
      return id;
    },

    /**
     * 存取数据
     *
     * @method data
     * @param {Object}obj 作为 key 的任意元素
     * @param {String}key 存储值的 key
     * @param {Object}value 需要存储的值
     */
    data: function(obj, key, value) {
      var id = this.getId(obj);
      if (arguments.length === 3) {//如果参数包含了 obj, key, value，则存储 value 到 obj.key
        if (!this.dataMap[id]) {
          this.dataMap[id] = {};
        }
        this.dataMap[id][key] = value;
        return value;
      } else { //否则尝试读取 obj.key 下的 value
        var data = null;
        try {
          data = this.dataMap[id][key];
        } catch(err) {
          data = undefined;
        }
        return data;
      }
    }
  };

  J.Cache = Cache;
})(J);

/**
 * 页面内容分析（正文提取）
 *
 * @module JTR
 * @submodule Page
 * @requires Cache
 */

(function(J) {

  /**
   * 网站页面对象，可以对其进行正文提取分析
   *
   * @class Page
   * @constructor
   * @param {DOMDocument}document
   */
  var Page = function(document) {
    /**
     * 上下文环境
     *
     * @property contentDocument
     * @private
     */
    this.contentDocument = document;

    /**
     * 缓存对象
     *
     * @property cache
     * @private
     */
    this.cache = new J.Cache();
  };

  Page.prototype = {
    IGNORE_TAGS: ['HTML', 'HEAD', 'META', 'TITLE', 'SCRIPT', 'STYLE',
      'LINK', 'IMG', 'FORM', 'INPUT', 'BUTTON', 'TEXTAREA', 'SELECT',
      'OPTION', 'LABEL', 'IFRAME', 'UL', 'OL', 'LI', 'DD', 'DT', 'A',
      'OBJECT', 'PARAM', 'EMBED', 'NOSCRIPT', 'EM', 'B', 'STRONG', 'I',
      'INS', 'BR', 'HR', 'PRE', 'H1', 'H2', 'H3', 'H4', 'H5', 'CITE'],

    /**
     * 提取正文
     * 若当前页面为google、facebook或twitter，返回空。
     * @method getMainArticle
     * @return {Article}
     */
    getMainArticle: function() {
      return null;

      var mainArticle = null,
        hostname = "";

      if (!!location) { //处理非正常的window对象，如百度搜索结果页面在IE下，window对象不正常
        hostname = location.hostname;
      }

      // 不提取 google/facebook/twitter 域下的页面
      if (/\b(google|facebook|twitter)\b/i.test(hostname)) {
        return null;
      }
      // 得到页面上所有可以提取内容的节点
      var elems = this._getAllArticle();

      // 如果没有任何节点就报错
      if (!(elems && elems.length)) {
        return null;
      }

      // 对节点按权值排序
      elems.sort(function(a, b) {
        return !!(b.weight - a.weight);
      });

      for (var i = 2; i > 0; i--) {  //todo:用途?
        mainArticle = elems[0];
        elems.splice(0, 1);
        break;
      }

      // 返回权值最大的节点
      return mainArticle;
    },

    /**
     * 获取页面中符合验证条件的文章
     *
     * @method _getAllArticle
     * @private
     * @return {Array}
     */
    _getAllArticle: function() {
      var allElems = this.contentDocument.getElementsByTagName('*'),
        elems = [];

      // 只取前 100 个节点，因为 IE 会卡死(浏览器性能太弱了...)
      for (var elemIndex = 0, length = allElems.length > 100 ? 100 : allElems.length; elemIndex < length; elemIndex++) {
        var elem = allElems[elemIndex];

        // 检查 element 的 tagName、大小、和样式
        if (this._checkTagName(elem) && this._checkSize(elem) && this._checkVisibility(elem)) {
          elems[elems.length] = new Article(elem);
        }
      }

      return elems;
    },

    /**
     * 检查一个元素的 TagName 是否符合要求
     *
     * @method _checkTagName
     * @param {DOMNode}elem
     * @private
     * @return {Boolean}
     */
    _checkTagName: function(elem) {
      return J.indexOf(this.IGNORE_TAGS, elem.tagName) == -1;
    },

    /**
     * 判断一个元素是否为隐藏元素
     *
     * @method _checkVisibility
     * @private
     * @param {DOMNode}elem
     * @return {Boolean}
     */
    _checkVisibility: function(elem) {
      return !(J.css(elem, 'visibility') == 'hidden' || J.css(elem, 'display') == 'none' || parseInt(J.css(elem, 'height')) <= 0 || parseInt(J.css(elem, 'width')) <= 0);
    },

    /**
     * 检查一个元素的大小是否符合要求
     *
     * @method _checkSize
     * @private
     * @param {DOMNode}elem
     * @return {Boolean}
     */
    _checkSize: function(elem) {
      return elem.offsetWidth > 300 && elem.offsetHeight > 200;
    }
  };

  /**
   * 文章对象
   *
   * @class Article
   * @constructor
   * @param {DOMNode}elem
   */
  var Article = function(elem) {
    /**
     * 文章对应的 DOM 元素
     *
     * @property elem
     */
    this.elem = elem;

    /**
     * DOM 元素中所有的文本内容结点
     *
     * @property _texts
     * @private
     */
    this._texts = this._getAllTexts();

    /**
     * 文章权重
     *
     * @property weight
     */
    this.weight = this.calcWeight();
  };

  Article.prototype = {
    IGNORE_TAGS: ['A', 'DD', 'DT', 'OL', 'OPTION', 'PRE', 'SCRIPT', 'STYLE', 'UL', 'IFRAME'],
    MINOR_REGEXP: /comment|combx|disqus|foot|header|menu|rss|shoutbox|sidebar|sponsor/i,
    MAJOR_REGEXP: /article|entry|post|body|column|main|content/i,
    TINY_REGEXP: /comment/i,
    BLANK_REGEXP: /\S/i,

    /**
     * 获取所有符合验证条件的文本内容结点
     *
     * @method _getAllTexts
     * @private
     * @return {Array}
     */
    _getAllTexts: function() {
      var textNodes = [],
        nodes = J.getTextNodes(this.elem);
      for (var textIndex = 0, length = nodes.length; textIndex < length; textIndex++) {
        var textNode = nodes[textIndex];
        if (this._checkTagName(textNode) && this._checkLength(textNode)) {  //todo:getTextNodes可以取到其他类型的节点吗？
          var parent = textNode.parentNode || {},
            grandParent = parent.parentNode || {};
          if (!(this._checkMinorContent(parent) || this._checkMinorContent(grandParent))) {
            textNodes.push(textNode);
          }
        }
      }
      return textNodes;
    },

    /**
     * 计算结构权重（dom 树越深权越低）
     *
     * @method calcStructWeight
     * @return {Number}
     */
    calcStructWeight: function() {
      var structWeight = 0;
      for (var textIndex = 0, textLength = this._texts.length; textIndex < textLength; textIndex++) {
        var text = this._texts[textIndex],
          length = text.nodeValue.length,
          weight = 1;
        if (length > 20) {
          continue;
        }

        for (var elem = text.parentNode; elem && elem != this.elem; elem = elem.parentNode) {
          weight -= 0.1;
        }

        structWeight += Math.pow(length * weight, 1.25);
      }
      return structWeight;
    },

    /**
     * 计算内容权重（判断 id/class 中是否包含有 content/article 等内容）
     *
     * @method calcContentWeight
     * @return {Number}
     */
    calcContentWeight: function() {
      var contentWeight = 1;
      for (var elem = this.elem; elem; elem = elem.parentNode) {
        var character = elem.id + ' ' + elem.className;
        if (this.MAJOR_REGEXP.test(character)) {
          contentWeight += 0.4;
        }
        if (this.MINOR_REGEXP.test(character)) {
          contentWeight -= 0.8;
        }
      }
      return contentWeight;
    },

    /**
     * 计算权重
     *
     * @method calcWeight
     * @return {Number}
     */
    calcWeight: function() {
      return this.calcStructWeight() * this.calcContentWeight();
    },

    /**
     * 检查 TagName
     *
     * @method _checkTagName
     * @param {DOMNode}elem
     * @private
     * @return {Boolean}
     */
    _checkTagName: function(elem) {
      return J.indexOf(this.IGNORE_TAGS, elem.tagName) == -1;
    },

    /**
     * 检查结点是否为空文本结点
     *
     * @method _checkLength
     * @param {DOMNode}elem
     * @private
     * @return {Boolean}
     */
    _checkLength: function(elem) {
      return Boolean(this.BLANK_REGEXP.test(elem.nodeValue));
    },

    /**
     * 检查结点是否为 comment 等无用元素
     *
     * @method _checkMinorContent
     * @param {DOMNode}elem
     * @private
     * @return {Boolean}
     */
    _checkMinorContent: function(elem) {
      return Boolean(this.TINY_REGEXP.test(elem.id + ' ' + elem.className));
    }
  };

  J.Page = Page;
})(J);

/**
 * 有道翻译助手 UI 模块
 * 负责协调控制 CDA/TR 等子模块
 *
 * @module JTR
 * @submodule UI
 * @author zhangyc
 * @author  wulj
 * @requires J, NodeManager, CDA, Swipe, Slider
 */

(function(J) {
  var DEFAULT_SETTINGS = {
    runCount: 0,
    swipe: true,
    mode: 'TIPS',
    level: 1
  };

  var LEVEL = {
    0: ['TIPS', 3],
    1: ['TIPS', 2],
    2: ['TIPS', 1],
    3: ['TRANS', '0'],
    4: ['NONE', 'NONE']
  };

  /**
   * Javascript TranslatoR 组件 JTR 的视图层
   * @class UI
   * @namespace outfox.translate.JTR
   * @constructor
   * @param {DOMObject}context 上下文环境
   * @param {Object}settings 设置参数
   * <ul>
   *  <li>reqSize: 数据包大小</li>
   *  <li>domain: 服务器所在域</li>
   *  <li>cssURL: 样式文件所在域</li>
   *  <li>tipsURL: 难词提示服务器接口 URL</li>
   *  <li>transURL: 全文翻译服务器接口 URL</li>
   *  <li>connFilePath: 跨域文件路径</li>
   * </ul>
   */

  J.TR.UI = function(context, settings) {
    var self = this;

    this.initLogger(settings.logURL);
    this.log({action: 'start'});

    /**
     * ID
     *
     * @property guid
     */
    this.guid = J.guid();

    /**
     * 上下文环境
     *
     * @property context
     */
    this.context = context;

    /**
     * 跨域通讯接口
     *
     * @property conn
     * @private
     */
    this.conn = J.CDA('OUTFOX_JTR_CDA', settings.domain, settings.connFilePath);

    /**
     * 更新提示
     */
    this.update = settings.update;
    /**
     * 版本更新提示
     */
    this.updateTipMsg = settings.updateTipMsg;
    /**
     * 版本更新日期
     */
    this.updateDate = settings.updateDate;

    /**
     * 结点管理
     *
     * @property manager
     * @private
     */
    this.manager = new J.NodeManager();

    /**
     * bar 的高度
     */
    this.barHeight = 50;
    /**
     * 权限限制提示
     */
    this.permissionDenied = '由于该网页存在安全性限制, 无法加载有道网页翻译2.0';

    /**
     * 翻译对象
     *
     * @property translator
     */
    this.translator = new J.TR(context, {
      reqSize: settings.reqSize,
      onStatusChange: function() {
        self._trStatusChangeCallback.apply(self, arguments);
      },
      url: {
        textTrans: settings.transURL,
        tips: settings.tipsURL
      },
      guid: this.guid
    }, this.conn, this.manager);

    /**
     * 控制各个翻译线程的锁
     *
     * @property queue
     * @private
     */
    this.queue = {
      TRANS:{
        0: { currentThread: -1 }
      },
      TIPS:{
        1: { currentThread: -1 },
        2: { currentThread: -1 },
        3: { currentThread: -1 }
      },
      NONE:{
        NONE: {}
      }
    };

    /**
     * 当前模式
     *
     * @property mode
     */
    this.mode = null;

    /**
     * 当前等级
     *
     * @property level
     */
    this.level = null;

    this.initFrame(settings.cssURL, function() {
      var href = "";
      var self = this;
      if (location) {
        href = location.href;
      }
      this.movePage(self.barHeight);
      this.frame.body.innerHTML = '\
                <div id="wrapper">\
                    <a href="http://fanyi.youdao.com/web2/?keyfrom=headerLogo" target="_blank">\
                        <h1 id="headerLogo" class="logo"></h1>\
                    </a>\
                    <div id="sliderLabel">翻译级别</div>\
                    <div id="sliderWrapper" class="slider-wrapper">\
                        <div id="levelLabel">\
                            <label id="level-3" rel="0"><a>专&nbsp;&nbsp;&nbsp;家</a></label>\
                            <label id="level-2" rel="1"><a>进&nbsp;&nbsp;&nbsp;阶</a></label>\
                            <label id="level-1" rel="2"><a>入&nbsp;&nbsp;&nbsp;门</a></label>\
                            <label id="level-0" rel="3"><a>全文翻译</a></label>\
                        </div>\
                        <div id="sliderContainer" class="slider-container">\
                            <div id="sliderBackground"><div class="slider-background"></div></div>\
                            <a id="slider" href="javascript:void(0);" class="slider"></a>\
                        </div>\
                    </div>\
                    <div id="status"></div>\
                    <div id="feedback">\
                        <a href="http://feedback.youdao.com/quality_report.jsp?q=jtr&prodtype=fanyi&cmt=' + encodeURIComponent('我在网站 ' + href + ' 使用有道网页翻译2.0时，遇到了以下问题：') + '" target="_blank">意见与反馈</a>\
                        &nbsp;<a id="fb" href="http://survey2.163.com/html/fanyiweb2s201103/paper.html" target="_blank">参加问卷调查</a>\
                    </div>\
                    <div id="switchWrapper"><a id="switch" href="javascript:void(0);"></a></div>\
                </div>\
                <a id="OUTFOX_JTR_BAR_CLOSE" href="javascript:void(0);" class="OUTFOX_JTR_BAR_CLOSE"></a>\
                <div id="OUTFOX_JTR_BAR_UPDATE_SHADE"></div>\
                <div id="OUTFOX_JTR_BAR_CLOSE_UPDATE_TIP">\
                    <div id="OUTFOX_JTR_BAR_CLOSE_UPDATE_TIP_CONTENT"></div>\
                </div>';
      this.initTipContent();
      this.initBarClose();
      this.initSwitch();
      this.initSlider();
      this.initLabel();
      this.initTipsCtrl();
      this.initTransTip();
      this.initSwipe();

      // 读入初始设置，进行默认翻译行为
      var defaultTrans=function(data){
        self.loadSetting(data);
        self.enable();
        self.writeSettings({
          runCount: self.settings.runCount + 1
        });

        J.each(LEVEL, function(key, value) {
          if (self.mode === value[0] && self.level === value[1]) {
            self.slider.to(key);
          }
        });
      };

      this.conn.ajax({
        handler:'localStorage',
        data:{key:'settings'},
        dataType: 'json',
        callback:function(data){
          data.level = 4;  //第一次默认为不翻译
          defaultTrans(data);
        }
      });
    });
  };

  J.TR.UI.prototype = {

    /**
     * 将元素放到可视窗口内，尽量显示出元素，绝对定位相对定位时，不包含包含块的margin，所以，应该除去这部分
     * TODO:和swipe.js中的swipte.initWrapper()方法可向上抽象
     */
    positionElementInViewPort:function(param) {
      var tip = param.tip;
      var target = param.target;

      //body 非静态定位时，消除 margin 的影响
      var isBodyPositioned = !!(J.css(document.body, 'position') !== 'static');
      var marginLeft = J.css(document.body, 'marginLeft');
      var marginRight = J.css(document.body, 'marginRight');
      //处理 margin 是 auto 时，marginLeft无法正确计算的问题
      if (marginLeft === 'auto' && marginRight === 'auto') {
        var pageWidth = J.getPageSize().page.width;
        var bodyCWidth = parseInt(J.css(document.body, 'width'));
        if (pageWidth > bodyCWidth) {
          marginLeft = (pageWidth - bodyCWidth) / 2;
        } else {
          marginLeft = 0;
        }
      }
      marginLeft = isBodyPositioned ? parseInt(marginLeft) : 0;
      var marginTop = isBodyPositioned ? parseInt(J.css(document.body, 'marginTop')) : 0;

      var pos = J.findPos(target),
        top = 0,
        left = 0,
        scrollTop = J.scroll().top,
        scrollLeft = J.scroll().left,
        targetLeft = pos.x,
        targetTop = pos.y,
        targetHeight = target.offsetHeight,
        tipHeight = tip.clientHeight,
        tipWidth = tip.clientWidth,
        bodyHeight = J.getPageSize().window.height,
        bodyWidth = J.getPageSize().window.width;

      if (targetTop - tipHeight >= scrollTop + this.barHeight) {
        top = targetTop - tipHeight;
      } else {
        top = targetTop + targetHeight;
      }

      if (targetLeft + tipWidth <= bodyWidth + scrollLeft) {
        left = targetLeft;
      } else {
        left = bodyWidth + scrollLeft - tipWidth;
      }

      J.css(param.tip, {
        position: 'absolute',
        top: (top - marginTop) + 'px',
        left: (left - marginLeft) + 'px'
      });
    },

    /**
     * 取消翻译
     *
     * @method disable
     */
    disable: function() {
      this.changeMode('NONE', 'NONE');
      this.slider.disable();
      this.frame.body.className = 'disable';
      this.disabled = true;
      this.updateStatus();
      this.switchElem.innerHTML = '重新翻译';
    },

    /**
     * 开启翻译
     *
     * @method enable
     */
    enable: function() {
      this.changeMode(this.settings.mode, this.settings.level);

      // 启用滑动条
      this.slider.enable();
      J.removeClass(this.frame.body, 'disable');
      J.addClass(this.frame.body, 'enable');
      this.disabled = false;

      // 更新状态提示
      this.updateStatus();

      // 设置切换按钮的文案
      this.switchElem.innerHTML = '取消翻译';
    },

    /**
     * 数据传送状态发生变化时的回调函数
     *
     * @method _trStatusChangeCallback
     * @private
     * @param {Object}data
     */
    _trStatusChangeCallback: function(data) {
      if (!data.id || !data.action || !data.level) {
        return;
      }
      var item = this.queue[data.action][data.level];
      if (item.currentThread <= data.id) {
        item.currentThread = data.id;
        item.status = data.status;
        item.data = data.data || null;
        if (data.action === this.mode && data.level === this.level) {
          this.updateStatus();
        }
      }
    },

    /**
     * 更新插件状态
     *
     * @method updateStatus
     */
    updateStatus: function() {
      var item = this.queue[this.mode][this.level];
      J.removeClass(this.statusElem.parentNode, 'statistic');
      if (item.status === 'busy' && item.data) {
        this.switchElem.style.visibility = 'hidden';
        var percentage = parseInt(item.data[0] * 100 / item.data[1], 10);
        if (this.mode === 'TRANS') {
          this.statusElem.innerHTML = '正在翻译&nbsp;' + percentage + '%&nbsp;...';
        } else {
          this.statusElem.innerHTML = '正在分析&nbsp;' + percentage + '%&nbsp;...';
        }
        this.statusElem.className = 'busy';
      } else if (item.status === 'finish') {
        this.switchElem.style.visibility = 'inherit';
        if (this.mode === 'TRANS') {
          this.statusElem.innerHTML = '翻译完成';
        } else {
          var num = this.manager.countTips(this.level);
          if (num !== 0) {
            J.addClass(this.statusElem.parentNode, 'statistic');
            this.statusElem.innerHTML = '共注释<span class="OUTFOX_BAR_TOTAL_NUM">' + num + '</span>个难词';
          } else {
            this.statusElem.innerHTML = '恭喜您！该网页上没有难词~';
          }
        }
        this.statusElem.className = 'finish';
      } else {
        this.switchElem.style.visibility = 'inherit';
        this.statusElem.innerHTML = '翻译助手已关闭';
        this.statusElem.className = 'finish';
      }
    },

    /**
     * 初始化 logger
     *
     * @method initLogger
     * @private
     */
    initLogger: function(url) {
      this.logURL = url;
      this._logImgCache = [];
    },

    /**
     * 记录 log
     *
     * @method log
     * @param {Object}param
     */
    log: function(param) {
      if (this.logURL) {
        param.relatedURL = document.location.href;
        param.guid = this.guid;

        var image = new Image();
        image.src = this.logURL + "?" + J.param(param) + '&' + (new Date()).getTime();
        this._logImgCache[this._logImgCache.length] = image;
      }
    },

    /**
     * 初始化划词翻译功能
     *
     * @method initSwipe
     * @private
     */
    initSwipe: function() {
      var self = this;
      this.swipe = J.Swipe(this.context, this.conn);
      this.swipe.onSwipeCallback = function(word) {
        self.log({
          action: 'swipeWord',
          word: word
        });
      };
    },

    /**
     * 移动原页面，以免翻译工具条将页面logo遮盖
     * @param height
     */
    movePage : function(height) {
      // 为保证特殊性最高，需直接增加设置到 body 的 style 上
      if (J.browser.msie) {
        var paddingTop = J.css(this.context, 'paddingTop');
        try {
          paddingTop = parseInt(paddingTop);
        } catch (err) {
          paddingTop = 0;
        }
        this.context.style.cssText += ";padding-top:" + (height + paddingTop) + 'px !important;';
      } else {
        var marginTop = J.css(this.context, 'marginTop');
        try {
          marginTop = parseInt(marginTop);
        } catch (err) {
          marginTop = 0;
        }
        //todo:很多页面的顶部导航部分根据 html 文档绝对定位，当翻译条处于文档最顶端时，会遮盖此部分，对用户体验造成恶劣的影响。因此，暂时将它的定位方式改为针对body定位。
        //todo:可能产生的问题：根据 html 定位正常的部分会定位错误。
        if (J.css(this.context, 'position') === 'static') {
          J.css(this.context, {'position': 'relative'});
        }
        this.context.style.cssText += ";margin-top:" + (height + marginTop) + 'px !important;';
      }
    },

    /**
     * 初始化顶部工具栏
     *
     * @method initFrame
     * @private
     * @param {String}cssURL 工具栏样式文件所在路径
     */
    initFrame: function(cssURL, callback) {
      var self = this;
      var wrapper = document.createElement('div');
      wrapper.id = "OUTFOX_BAR_WRAPPER";

      this.context.appendChild(wrapper);
      this.wrapper = wrapper;

      function createIframeAndHackIECrossDomain(wrapper) {
        wrapper.innerHTML = '<iframe id="OUTFOX_JTR_BAR" src="" style="display:none;"></iframe>';
        var iframe = J.query('#OUTFOX_JTR_BAR');
        iframe.setAttribute('frameBorder', 0);

        //设置子域域名为父域的域名，IE中需这样跨域，src为空的方式无法跨域
        if (J.browser.msie && document.domain != window.location.hostname) {
          iframe.src = "javascript:void(document.write(\"<script>document.domain='" + document.domain + "';<\/script><body></body>\"))";
        }
        //IE浏览器，非IE8标准模式下，宽度 100% 会预留一个滚动条的宽度，所以使用 js 计算宽度
        if (J.browser.msie && !(J.browser.msie === '8.0' && document.compatMode === 'CSS1Compat')) {
          J.css(iframe, {width:J.getPageSize().window.width + 'px'});
          J.bind(window, 'resize', function(ev) {
            J.css(iframe, {width:J.getPageSize().window.width + 'px'});
          });
        }
        return iframe;
      }

      var iframe = createIframeAndHackIECrossDomain(wrapper);
      this.iframe = iframe;

      setTimeout(function() { // 跳出执行队列，等待 wrapper 加载完成后再继续执行
        try {
          self.frame = iframe.contentDocument || iframe.contentWindow.document;
        } catch(err) {
          self.log({action: 'secRestrict', relatedURL: window.location.href});
          alert(self.permissionDenied);
          return;
        }

        J.css(iframe,{display:'block'});
        J.addClass(iframe, 'OUTFOX_JTR_BAR');
        J.loadCSS(self.frame, cssURL);
        self.frame.body.id = 'OUTFOX_JTR_BAR_BODY';
        J.addClass(self.frame.body, 'forbid-select'); // 解决Firefox中可以选中bar中文本的问题
        self.frame.body.onselectstart = self.frame.body.ondrag = function() { // 解决IE中可以选中bar中文本的问题
          return false;
        };
        callback.call(self);
      }, 100);
    },

    /**
     * 初始化翻译工具条关闭按钮
     */
    initBarClose:function() {
      var self = this;
      var cButton = this.frame.getElementById('OUTFOX_JTR_BAR_CLOSE');
      J.addClass(cButton, 'OUTFOX_JTR_BAR_CLOSE');
      J.bind(window, 'resize', function(ev) {
        J.css(cButton, {
          top: 1 + 'px',
          right:1 + 'px'
        });
      });
      J.bind(cButton, 'click', function() {
        self.disable();
        self.movePage(-self.barHeight);
        self.context.removeChild(self.wrapper);
        self.context.removeChild(J.query('#OUTFOX_JTR_CDA'));
        self.context.removeChild(J.query('#yddWrapper'));
        self.context.removeChild(J.query('#outfox_seed_js'));
      });
    },

    /**
     * 初始化更新提示
     */
    initTipContent: function() {
      if (!this.update) {
        return;
      }
      var self=this;
      var showTip=function(){
        var tipContent = J.query('#OUTFOX_JTR_BAR_CLOSE_UPDATE_TIP_CONTENT',self.frame);
        var shade = J.query('#OUTFOX_JTR_BAR_UPDATE_SHADE',self.frame);
        var tip = J.query('#OUTFOX_JTR_BAR_CLOSE_UPDATE_TIP',self.frame);
        tipContent.innerHTML = '更新提示：<br/>' +
          self.updateTipMsg + '<span class="update-date">' + self.updateDate + '</span>' +
          '<a href="javascript:void(0);" id="OUTFOX_JTR_BAR_CLOSE_UPDATE_TIP_CONTENT_CLOSE"></a>';
        var tipClose = J.query('#OUTFOX_JTR_BAR_CLOSE_UPDATE_TIP_CONTENT_CLOSE',self.frame);
        J.css(shade, {display:'block'});
        J.css(tip, {display:'block'});
        J.bind(tipClose, 'click', function() {
          J.css(shade, {'display':'none'});
          J.css(tip, {'display':'none'});
        });
      };
      self.conn.ajax({
        handler:'localStorage',
        data:{key:'date'},
        callback:function(response){
          if(response !== self.updateDate){
            showTip();
            self.conn.ajax({
              handler:'localStorage',
              data:{key:'date',value:self.updateDate}
            });
          }
        }
      });
    },


    /**
     * 初始化状态切换的按钮
     *
     * @method initSwitch
     */
    initSwitch: function() {
      var self = this;
      this.statusElem = J.query('#status',this.frame);
      this.switchElem = J.query('#switch',this.frame);
      J.bind(this.switchElem, 'click', function(e) {
        if (self.disabled) {
          self.enable();
        } else {
          self.disable();
        }
      });
    },

    /**
     * 初始化标签(点击标签的事件等等)
     *
     * @method initLabel
     */
    initLabel: function() {
      this.labels = [];
      var self = this;
      var listener = function(e) {
        var evt = e || window.event,
          target = evt.target || evt.srcElement,
          id = target.parentNode.getAttribute('rel');
        if (self.disabled) {
          return;
        }
        if (id) {
          self.changeMode(LEVEL[id][0], LEVEL[id][1]);
          J.each(LEVEL, function(key, value) {
            if (self.mode === value[0] && self.level === value[1]) {
              self.slider.to(key);
            }
          });
        }
      };
      for (var i = 0; i < 4; i++) {
        this.labels[i] = J.query('#level-' + i, this.frame);
        J.bind(this.labels[i], 'click', listener);
      }
    },

    /**
     * 初始化顶部滚动条
     *
     * @method initSlider
     * @private
     */
    initSlider: function() {
      var container = J.query('#sliderContainer', this.frame);
      var controller = J.query('#slider', this.frame);

      var self = this, timer = null, INTERVAL = 10;
      this.slider = new J.Slider(container, controller, {
        bar: J.query('#sliderBackground', this.frame),
        max: 3,
        min: 0,
        step: 1,
        borderFix: -3,
        callback: function(data) {
          clearTimeout(timer);
          timer = setTimeout(function() {
            self._valueChange(data);
          }, INTERVAL);
        }
      });
    },

    /**
     * 载入设置参数
     *
     * @method loadSetting
     * @param {Object}data 设置参数
     *  mode: 翻译模式
     *  level: 翻译级别
     */
    loadSetting: function(data) {
      var settings = {};
      if (data === null || Object.prototype.toString.call(data) !== '[object Object]') { //如果没有传入 data 参数, 就使用默认设置
        //this.conn.localSet('settings', DEFAULT_SETTINGS);
        this.conn.ajax({
          handler:'localStorage',
          dataType: 'json',
          data:{key:'settings',value:JSONDAO.stringify(DEFAULT_SETTINGS)}
        });
        settings = DEFAULT_SETTINGS;
      } else {
        // 否则就结合使用默认设置和 data 中的设置
        for (var key in DEFAULT_SETTINGS) {
          if (DEFAULT_SETTINGS.hasOwnProperty(key)) {
            settings[key] = data.hasOwnProperty(key) ? data[key] : DEFAULT_SETTINGS[key];
          }
        }
      }
      // 设置 JTR 的翻译模式和等级
      settings.mode = settings.mode || DEFAULT_SETTINGS.mode;
      settings.level = settings.level || DEFAULT_SETTINGS.level;
      J.log('Load Settings:', settings);
      this.settings = settings;
    },

    /**
     * 顶部 slider valueChange 事件回调函数
     *
     * @method _valueChange
     * @private
     */
    _valueChange: function(data) {
      var val = Math.round(data), newMode = LEVEL[val][0], newLevel = LEVEL[val][1];
      if (newMode !== this.mode) {
        this.changeMode(newMode, newLevel);
      } else if (newLevel !== this.level) {
        this.changeLevel(newLevel);
      }
    },

    /**
     * 更换模式和翻译级别
     *
     * @method changeMode
     * @param {String}mode
     * @param {String}level
     * @param {Number}level
     */
    changeMode: function(mode, level) {
      // 取消当前模式下的所有更改
      if (this.mode === 'TIPS') {
        for (var i = 1; i <= 3; i++) {
          this.labels[i].className = 'deactive';
        }
        this.translator.revertTips();
      } else if (this.mode === 'TRANS') {
        this.labels[0].className = 'deactive';
        this.translator.revertTrans();
      }
      //this.swipe.disableSwipe();
      this.disableTransTip();
      this.disableTipsCtrl();

      this.mode = mode;
      this.changeLevel(level);
    },

    /**
     * 更换翻译级别
     *
     * @method changeLevel
     * @param {String}level
     * @param {Number}level
     */
    changeLevel: function(level) {
      J.log('Change level to:', level);
      if (this.level === null) {
        // 用户首次访问
        this.log({
          action: 'view',
          level: level
        });
      } else {
        this.log({
          action: 'changeLevel',
          oldLevel: this.level,
          newLevel: level
        });
      }
      this.level = level;

      if (this.mode === 'TIPS') {
        this.swipe.enableSwipe();
        for (var i = 1; i <= 3; i++) {
          this.labels[i].className = i == level ? 'active' : 'deactive';
        }
        this.translator.revertTips();
        this.translator.doTips(this.level);
        this.enableTipsCtrl();
      } else if (this.mode === 'TRANS') {
        this.labels[0].className = 'active';
        this.translator.doTrans();
        this.enableTransTip();
      }

      if (this.mode !== 'NONE') {
        this.writeSettings({
          mode: this.mode,
          level: this.level
        });
      }
    },

    /**
     * 写入设置参数
     *
     * @method writeSettings
     * @param {Object}data 设置参数
     *  reqSize: 数据包大小
     *  domain: 服务器所在域
     *  cssURL: 样式文件所在域
     *  tipsURL: 难词提示服务器接口 URL
     *  transURL: 全文翻译服务器接口 URL
     *  connFilePath: 跨域文件路径
     */
    writeSettings: function(data) {
      J.each(data, function(key, value) {
        this.settings[key] = value;
      }, this);
      this.conn.ajax({
        handler:'localStorage',
        dataType: 'json',
        data:{key:'settings',value:JSONDAO.stringify(this.settings)}
      });
    },

    /**
     * 初始化难词提示模式下的浮动控制 UI
     *
     * @method initTipsCtrl
     * @private
     */
    initTipsCtrl: function() {
      var self = this,
        controlBar = this.initTipsCtrlElem();

      var tipsCtrlTimer = null;
      this.tipsTarget = null;
      this.tipsCtrlHandler = function(e) {
        var evt = e || window.evt, target = evt.target || evt.srcElement, x = 0, y = 0;
        clearTimeout(tipsCtrlTimer);
        if (target === self.tipsTarget || target.className && target.className.indexOf('OUTFOX_JTR_NANCI_') !== -1) {
          return;
        }
        // 定时检测划词内容
        tipsCtrlTimer = setTimeout(function() {
          if (controlBar.parentNode) {
            controlBar.parentNode.removeChild(controlBar);
          }
          if (J.hasClass(target, 'OUTFOX_NANCI_TIPS')) {
            var pos = J.findPos(target),
              word = J.query('.OUTFOX_JTR_NANCI_CTRL_WORD',controlBar)[0],
              style = null;
            self.context.appendChild(controlBar);
            word.innerHTML = target.innerHTML;
            // 设置提示框的字体，尽量和原文一致
            var size = J.css(target, 'fontSize');
            var family = J.css(target, 'fontFamily');
            try {
              if (size.indexOf('em') != -1) {
              } else if (parseInt(size) < 12) {
                size = '12px';
              }
            } catch(err) {
              size = '12px';
            }
            //body 非静态定位时，消除 margin 的影响
            var isBodyPositioned = !!(J.css(document.body, 'position') !== 'static');
            var marginLeft = J.css(document.body, 'marginLeft');
            var marginRight = J.css(document.body, 'marginRight');
            //处理 margin 是 auto 时，marginLeft无法正确计算的问题
            if (marginLeft === 'auto' && marginRight === 'auto') {
              var pageWidth = J.getPageSize().page.width;
              var bodyCWidth = parseInt(J.css(document.body, 'width'));
              if (pageWidth > bodyCWidth) {
                marginLeft = (pageWidth - bodyCWidth) / 2;
              } else {
                marginLeft = 0;
              }
            }
            marginLeft = isBodyPositioned ? parseInt(marginLeft) : 0;
            var marginTop = isBodyPositioned ? parseInt(J.css(document.body, 'marginTop')) : 0;
            J.css(word, {'fontSize': size});
            J.css(word, {'fontFamily': family});
            J.css(controlBar, {
              left: (pos.x - marginLeft) + 'px',
              top: (pos.y - marginTop) + 'px',
              position: 'absolute'
            });
            self.tipsTarget = target;
          } else {
            self.tipsTarget = null;
          }
        }, 200);
      };
    },

    /**
     * 初始化难词提示模式下的控制栏 DOM 元素
     *
     * @method initTipsCtrlElem
     * @private
     */
    initTipsCtrlElem: function() {
      var controlBar = document.createElement('span'),
        detailbg = document.createElement('span'),
        detail = document.createElement('a'),
        closebg = document.createElement('span'),
        close = document.createElement('a'),
        word = document.createElement('span'),
        self = this;

      word.className = 'OUTFOX_JTR_NANCI_CTRL_WORD';
      controlBar.appendChild(word);

      detail.className = 'OUTFOX_JTR_NANCI_CTRL_DETAIL';
      detail.setAttribute('title', '查看详细解释');
      detail.innerHTML = '详解';
      detailbg.appendChild(detail);

      detailbg.className = 'OUTFOX_JTR_NANCI_CTRL_DETAIL_BG';
      controlBar.appendChild(detailbg);

      close.className = 'OUTFOX_JTR_NANCI_CTRL_CLOSE';
      close.setAttribute('title', '我知道了');
      close.innerHTML = '关闭';
      closebg.appendChild(close);

      closebg.className = 'OUTFOX_JTR_NANCI_CTRL_CLOSE_BG';
      controlBar.appendChild(closebg);

      controlBar.className = 'OUTFOX_JTR_NANCI_BAR';

      var getTarget = function() {
        var elem = null;
        try {
          elem = self.tipsTarget.previousSibling;
        } catch(e) {
        }
        return elem;
      };

      /**
       * 选中某元素中的文本
       * @param elem  元素
       */
      var selectTextIn = function(elem) {
        var range = null;
        if (document.createRange) {
          var selection = window.getSelection();
          range = document.createRange();
          // 选中该文本结点后调用划词插件翻译该文本
          selection.removeAllRanges();
          range.selectNode(elem);
          selection.addRange(range);
        } else if (document.body.createTextRange) {
          range = document.body.createTextRange();
          range.moveToElementText(elem);
          range.select();
        }
      };

      // 绑定点击详细按钮的行为
      J.bind(detail, 'click', function(evt) {
        var word = getTarget();
        if (word && self.swipe) {
          self.log({
            action: 'viewDetail',
            word: word.innerHTML
          });
          selectTextIn(word);

          var probe = document.createElement('font');
          probe.innerHTML = "&nbsp";
          word.appendChild(probe);
          var position = J.findPos(probe),
            height = probe.offsetHeight;
          word.removeChild(probe);
          self.swipe.swipeWord(word.firstChild.nodeValue, position.x, position.y, 0, height);
        }
        controlBar.parentNode.removeChild(controlBar);
        J.removeClass(self.tipsTarget, 'on');
      });

      // 绑定点击关闭按钮的行为
      J.bind(close, 'click', function(evt) {
        var index = controlBar.getAttribute('rel'),
          word = getTarget();
        if (word) {
          self.log({
            action: 'closeTip',
            word: word.innerHTML,
            tip: self.tipsTarget.innerHTML
          });
          self.translator._manager.revertTip(word);
        }
        controlBar.parentNode.removeChild(controlBar);
        J.removeClass(self.tipsTarget, 'on');
      });

      return controlBar;
    },

    /**
     * 查找难词的位置
     * 插入一个探针(probe)，并不断移动 probe，依次读取它的位置信息，最终得到一个难词的开始和结束的坐标
     *
     * @method _findTipCtrlPosition
     */
    _findTipCtrlPosition: function(tipElem, eventPos) {
      var text = tipElem.firstChild,
        originalText = text.nodeValue,
        len = text.nodeValue.length,
        probe = document.createElement('font'),
        after = document.createTextNode(''),
        pos = [0, 0],
        maxOffsetX = null,
        maxOffsetY = null,
        currentPos = null,
        offsetX = 0,
        offsetY = 0,
        textOffsetStart = 0,
        textOffsetEnd = len,
        textOffsetY = null;
      J.css(probe, {
        border: 'none',
        padding: 0,
        margin: 0
      });

      for (var i = 0; i <= len; i++) {
        after.nodeValue = text.nodeValue.substr(i);
        text.nodeValue = text.nodeValue.substr(0, i);
        tipElem.insertBefore(after, text.nextSibling);
        tipElem.insertBefore(probe, text.nextSibling);
        currentPos = J.findPos(probe);

        offsetX = currentPos.x - eventPos[0];
        offsetY = currentPos.y - eventPos[1];

        if (offsetY <= 0 && (maxOffsetY === null || offsetY > maxOffsetY)) {
          textOffsetY = maxOffsetY = offsetY;
          pos[0] = currentPos.x;
          pos[1] = currentPos.y;
          maxOffsetX = null;
          textOffsetStart = i;
        }

        if (offsetY !== textOffsetY) {
          textOffsetEnd = i;
          textOffsetY = offsetY;
        }

        text.nodeValue = originalText;
        tipElem.removeChild(after);
        tipElem.removeChild(probe);
      }

      probe.innerHTML = text.nodeValue.substr(textOffsetStart, textOffsetEnd);
      text.nodeValue = text.nodeValue.substr(0, textOffsetStart);
      tipElem.insertBefore(probe, text.nextSibling);

      //pos = J.findPos(probe);
      pos[0] += probe.offsetWidth;
      tipElem.removeChild(probe);
      text.nodeValue = originalText;

      return pos;
    },

    /**
     * 禁止关闭
     */
    preventClose:function() {
      J.css(J.query('#OUTFOX_JTR_BAR_CLOSE',this.frame), {display: 'none'});
    },

    /**
     * 启用难词提示浮动控制栏
     *
     * @method enableTipsCtrl
     */
    enableTipsCtrl: function() {
      J.bind(this.context, 'mouseover', this.tipsCtrlHandler);
    },

    /**
     * 关闭难词提示浮动控制栏
     *
     * @method disableTipsCtrl
     */
    disableTipsCtrl: function() {
      J.unbind(this.context, 'mouseover', this.tipsCtrlHandler);
    },

    /**
     * 开启原文翻译模式下的原文提示
     *
     * @method enableTransTip
     */
    enableTransTip: function() {
      J.bind(this.context, 'mouseover', this.transTipHandler);
    },

    /**
     * 关闭原文翻译模式下的原文提示
     *
     * @method disableTransTip
     */
    disableTransTip: function() {
      J.unbind(this.context, 'mouseover', this.transTipHandler);
    },

    /**
     * 初始化全文翻译模式下的原文提示 UI
     *
     * @method initTransTip
     * @private
     */
    initTransTip: function(evt) {
      var self = this,
        lastTarget = null, // 保存最后一个被提示的元素
        transTipTimmer = null;
      this.initTransTipElem('', '');

      this.transTipHandler = function(e) {
        var evt = e || window.event, target = evt.target || evt.srcElement;
        clearTimeout(transTipTimmer);
        transTipTimmer = setTimeout(function() {
          if (lastTarget === target || target.className && (target.className.indexOf('OUTFOX_JTR_TRANSTIP_') !== -1 || target.className.indexOf('ydd-') !== -1 )) {
            return;
          }
          if (lastTarget) {
            lastTarget.style.textDecoration = 'none';
          }
          if (self.transTipElem.elem.parentNode) {
            self.transTipElem.elem.parentNode.removeChild(self.transTipElem.elem);
          }
          if (J.hasClass(target, 'OUTFOX_JTR_TRANS_NODE')) {
            lastTarget = target;

            var index = target.getAttribute('rel'),
              manager = self.translator._manager;

            self.resetTransTipElem(manager.originals[index], manager.transResults[index], index);

            self.context.appendChild(self.transTipElem.elem);
            self.positionElementInViewPort({
              target:target,
              tip:self.transTipElem.elem
            });
            target.style.textDecoration = 'underline';
          } else {
            lastTarget = null;
          }
        }, 200);
      };
    },

    /**
     * 初始化全文翻译模式下的原文提示 DOM 元素
     *
     * @method initTransTipElem
     * @private
     */
    initTransTipElem: function() {
      var self = this,
        transTipDiv = document.createElement('div');

      transTipDiv.className = 'OUTFOX_JTR_TRANSTIP_WRAPPER';

      var trans = document.createTextNode('');
      var original = document.createTextNode('');
      transTipDiv.innerHTML += '<div class="OUTFOX_JTR_TRANSTIP_ORIGIN">\
                                        <div class="ydd-container">\
                                          <div class="ydd-top-wrapper">\
                                            <div class="ydd-top">\
                                            </div>\
                                          </div>\
                                          <div class="ydd-body-wrapper">\
                                            <div class="ydd-lb"></div>\
                                            <div class="ydd-rb"></div>\
                                            <div class="ydd-body">\
                                              <div class="ydd-title">\
                                                <strong>原文：</strong>\
                                              </div>\
                                              <div class="ydd-middle">\
                                                <div class="OUTFOX_JTR_TRANSTIP_ORIGIN_TEXT"></div>\
                                                <div class="OUTFOX_JTR_TRANSTIP_ADVISE">\
                                                  <textarea class="OUTFOX_JTR_TRANSTIP_ADVISE_TEXT"></textarea>\
                                                  <a class="OUTFOX_JTR_TRANSTIP_ADVISE_SUBMIT" href="javascript:void(0);">提交翻译建议</a>\
                                                </div>\
                                              </div>\
                                            </div>\
                                          </div>\
                                          <div class="ydd-bottom-wrapper">\
                                            <div class="ydd-bottom">\
                                              <a class="OUTFOX_JTR_TRANSTIP_ADVISE_TOGGLE">更好的翻译建议</a>\
                                              <span class="OUTFOX_JTR_TRANSTIP_ADVISE_THANK">感谢您为有道提供建议^_^</span>\
                                            </div>\
                                          </div>\
                                          <div class="ydd-bg-top"></div>\
                                        </div>\
                                      </div>';
      J.query('.OUTFOX_JTR_TRANSTIP_ORIGIN_TEXT',transTipDiv)[0].appendChild(original);
      J.query('.OUTFOX_JTR_TRANSTIP_ADVISE_TEXT',transTipDiv)[0].appendChild(trans);

      var toggle = J.query('.OUTFOX_JTR_TRANSTIP_ADVISE_TOGGLE',transTipDiv)[0],
        adviseSubmit = J.query('.OUTFOX_JTR_TRANSTIP_ADVISE_SUBMIT',transTipDiv)[0],
        adviseDiv = J.query('.OUTFOX_JTR_TRANSTIP_ADVISE',transTipDiv)[0],
        bottom = J.query('.ydd-bottom',transTipDiv)[0],
        transTextContainer = J.query('.OUTFOX_JTR_TRANSTIP_ADVISE_TEXT',transTipDiv)[0];

      adviseSubmit.hideFocus = true;
      J.bind(toggle, 'click', function() {
        J.toggleClass(adviseDiv, 'expand');
        J.css(toggle, {display: 'none'});
      });

      /**
       * 处理文本中的特殊字符
       * TODO: 剥离成为公共方法
       * @param text
       */
      var dealWithSpecific = function(text) {
        text = text.replace(/</g, '&lt;')
          .replace(/>/g, '&gt;');
        return text;
      };
      J.bind(adviseSubmit, 'click', function() {
        var transBack = transTextContainer.value;
        if (transBack === '') {
          alert('翻译建议不能为空，请您输入内容后再次提交');
          return;
        }
        transBack = dealWithSpecific(transBack);
        J.addClass(adviseDiv, 'finish');
        J.removeClass(adviseDiv, 'expand');
        J.addClass(bottom, 'OUTFOX_JTR_TRANSTIP_ADVISE_THANK_TIP');
        var index = self.transTipElem.index;

        if (index && self.manager.transResults[index]) {
          self.manager.transResults[index] = transBack;
          self.manager.revertTrans(index);
          self.manager.replaceTrans(index);
          // TODO: 把用户修改的译文发回服务器
        }
      });

      this.transTipElem = {
        elem: transTipDiv,
        transTextContainer:transTextContainer,
        trans: trans,
        original: original,
        toggle: toggle,
        submit: adviseSubmit,
        advise: adviseDiv,
        bottom: bottom,
        index: null
      };
    },

    resetTransTipElem: function(origin, trans, index) {
      J.removeClass(this.transTipElem.advise, 'finish');
      J.removeClass(this.transTipElem.advise, 'expand');
      J.removeClass(this.transTipElem.bottom, 'OUTFOX_JTR_TRANSTIP_ADVISE_THANK_TIP');
      this.transTipElem.toggle.innerHTML = '提交翻译建议';
      J.css(this.transTipElem.toggle, {display: ''});
      this.transTipElem.transTextContainer.value = trans;
      this.transTipElem.original.nodeValue = origin;
      this.transTipElem.index = index;
    }
  }
})(J);
/*
 * Javascript TranslatoR 组件 JTR 初始化代码
 *
 * @author zhangyc
 */

(function (d) {
  var f = "http://fanyi.youdao.com/web2";
  var g = "http://fanyi.youdao.com";
  var h = "/web2/conn.html";
  var c = f + "/index.do";
  var a = g + "/jtr";
  var e = f + "/rl.do";
  var b = f + "/styles/all-packed.css";
  d.loadCSS(document, b);
  window.OUTFOX_JavascriptTranslatoR = new d.TR.UI(document.body, {
    domain: g,
    update: false,
    updateTipMsg: "修复链接错误",
    updateDate: "2013-12-24",
    cssURL: b,
    tipsURL: c,
    transURL: a,
    logURL: e,
    connFilePath: h,
    reqSize: 20
  });

  OUTFOX_JavascriptTranslatoR.wrapper.style.display = "none";
  OUTFOX_JavascriptTranslatoR.context.style.cssText += ";margin-top:auto!important;";
  //禁止选词
  OUTFOX_JavascriptTranslatoR.disableTipsCtrl();
  OUTFOX_JavascriptTranslatoR.disableTransTip();


  var LEVEL = {
    0: ['TIPS', 3],
    1: ['TIPS', 2],
    2: ['TIPS', 1],
    3: ['TRANS', '0'],
    4: ['NONE', 'NONE']
  };

  window.changeLevelWithNum = function(num){
    OUTFOX_JavascriptTranslatoR.changeMode(LEVEL[num][0], LEVEL[num][1]);
  };
  //window.changeLevelWithNum(4);
})(J);


