/**
 * IOS 客户端的点击取词
 * To change this template use File | Settings | File Templates.
 */
 var dict ={};
 dict.queryWordNative=function(cword,sentence,x,y){
    window.readBrowserApi.showTranslate(cword,sentence,x,y);
 };
 dict.closeNativeQueryWord=function(){
    window.readBrowserApi.hideTranslate();
 };
 
(function() {
    var targetTouch, 
           targetCoord = {}, 
        targetRealCoord = {}, 
        currentWord,  
        rawCurrentWord, 
        content, 
        range,  
        click,  
        driver,
        isDisabled = false, 
        highlightNode,  
        ignored = ['video', 'audio', 'img'],
        ua = navigator.userAgent.toLowerCase();

    var isEngWord = function(chars) {
        return (/^[a-zA-Z\-]+$/).test(chars);
    };

    var highlightTargetHtml = function() {
        content = range.extractContents();
        var node = highlightNode = document.createElement('span');
        node.className = 'hl';
        node.innerHTML = rawCurrentWord;
        range.insertNode(node);
    };

    var removeHighlight = function() {
        if (!range || !content || !highlightNode || !highlightNode.parentNode) {
            return;
        }
        highlightNode.parentNode.removeChild(highlightNode);  
        var nnode = document.createElement('span');
        nnode.innerHTML = rawCurrentWord;
        range.insertNode(nnode);
        range = null;
    };


    var hideResult = function() {
        if (driver.closeNativeQueryWord) {
            driver.closeNativeQueryWord();
        }
        removeHighlight();
    };
   
     var getWord = function(x, y) {
        range = document.caretRangeFromPoint(x, y);
        if (!range) {
            return '';
        }

        range.expand("word");
        targetRealCoord.cx = range.getBoundingClientRect().left;
        targetRealCoord.cy = range.getBoundingClientRect().top;
        return range.cloneContents().textContent;
    };
    
      var getSentence = function(x, y) {
        range = document.caretRangeFromPoint(x, y);
        if (!range) {
            return '';
        }

        range.expand("sentence");
        targetRealCoord.cx = range.getBoundingClientRect().left;
        targetRealCoord.cy = range.getBoundingClientRect().top;
        return range.cloneContents().textContent;
    };
    
    
    var filterNode = function(node) {
        var result = true;
        while (node != document.body) {
            if (node && node.tagName.toLowerCase() == "a") {
                result = false;
                break;
            } else {
                node = node.parentNode;
            }
        }
        return result;
    };
    

    var mainDic = function(event,endE) {

        if (!filterNode(event.target)) return;
        hideResult();

        if (isDisabled) return;

        targetTouch = event.touches[0];
        targetCoord.px = targetTouch.pageX;
        targetCoord.py = targetTouch.pageY;
        targetCoord.cx = targetTouch.clientX;
        targetCoord.cy = targetTouch.clientY;
        var element = document.elementFromPoint(targetCoord.cx, targetCoord.cy);

        if (ignored.indexOf(element.tagName) > -1) {
            return;
        }
        var currentSentence = getSentence(targetCoord.cx, targetCoord.cy);

        rawCurrentWord = getWord(targetCoord.cx, targetCoord.cy);
        currentWord= rawCurrentWord.replace(/\s+/g, '');
        if (!isEngWord(currentWord) || element.innerText.indexOf(currentWord) < 0) {
            range = null;
            return;
        }

        highlightTargetHtml();
        exec({
            word: currentWord,
            sentence:currentSentence,
            pos: {
                x: Math.floor(targetRealCoord.cx + highlightNode.offsetWidth / 2),
                y: Math.floor(targetRealCoord.cy + highlightNode.offsetHeight / 2)
            }
        });
        return true;
    };
     
 
    var tapHoldTriger = null,
        move = false,
        startE = null,
        endE = null,
        init = function(mode) {
            var body = document.body;
            click = mode === 'click';
            driver = window.dict ? window.dict : {};
            body.addEventListener("touchstart", function(event) {
                hideResult();
                move = false;
                startE = event;
                tapHoldTriger = setTimeout(function() {
                    mainDic(startE);
                },
                500);
            }, false);
            body.addEventListener("click", function(event) {
            }, false);
            body.addEventListener("touchmove", function() {
                move = true; 
                clearTimeout(tapHoldTriger);
            }, false);
            body.addEventListener("touchend", function(event) {
                endE =event; 
                clearTimeout(tapHoldTriger);
            }, false);

            var styleTag = document.createElement('style'),
                defaultCSS = ([
                    '.hl{',
                    'background-color: #5EA2FF;',
                    'color: #ffffff;',
                    '}'
                ]).join('\n');
            styleTag.id = 'catchword-style';
            styleTag.innerHTML = defaultCSS;
            document.querySelector('head').appendChild(styleTag);
        };

    var exec = function(opt) {
        opt.webViewWidth = window.innerWidth;
        opt.webViewHeight = window.innerHeight;

        if (/android/i.test(ua)) {
            if (driver.queryWordNative) {
                driver.queryWordNative(
                    opt.word,
                    opt.sentence,
                    opt.pos.x / window.innerWidth,
                    opt.pos.y / window.innerHeight
                );
            }
        } else if (/ipad/i.test(ua) || /iphone/i.test(ua) || /ipod/i.test(ua)) {
            var str = JSON.stringify(opt);
            var url = 'youdaobs://word_capturing_for_ios/' + str;
            document.location = url;
        }
    };
    window.catchWord = {
        init: init,
        setDisabled: function(val) {
            isDisabled = !!val;
        },
        hideResult: hideResult
    };
    init('click');
}());
